#include <windows.h>
#include <stdio.h>
#include <math.h>
#include <commctrl.h>
#include "htmlhelp.h"
#include "setwin.h"
#include "setscrollbar_img.h"
#include <GdiPlus.h>
using namespace 	Gdiplus;
#include "gdip_rect.h"
#include "resource.h"

#pragma comment(lib,"GdiPlus.lib")
#pragma comment(lib,"HtmlHelp.lib")
#pragma comment(lib,"Comctl32.lib")

#define MYWNDTITLE				"MPARTS"
#define MYWNDCLASS				"MPARTS_CLASS"
#define MYCHILDCLASS			"MPARTS_CHILD_CLASS"
#define SAFE_DELETE_OBJ(p)		if (p){delete  p;p=NULL;}
#define SAFE_DELETE_ARRAY(p)	if (p){delete[]p;p=NULL;}
#define FREE(p)					free(p);p=NULL;
#define M_MAX					256	 	// [V̍ő吔
#define P_MAX					256 	// p[c+jbg̍ő吔
#define LEN						64		// p[c̍ő咷
#define TAG_LEN 				256		// ECTiBINjt@C̃^O̍ő啶
#define VER_LEN					256		// o[W̍ő咷

#define ID_EDITZ				1401
#define ID_LIST					1402

GdiplusStartupInput				gdiSI;
ULONG_PTR						gdiToken;

typedef struct{
	float	x;
	float	y;
	float	z;
}VEC3,*LPVEC3;

typedef struct{
	int 	iStart;			// Jn[Vԍ
	int 	iEnd;			// I[Vԍ
	bool 	flag_loop;		// [v tO
	char	name[LEN];		// Aj
}ANIMSET;

typedef struct{
	char 	filename[MAX_PATH];	// t@C
	char 	strVer[VER_LEN];	// o[W
	int 	t_vtx_ct;			// _
	int 	t_face_ct;			// ʐ
	int 	parts_ct;			// p[c
	VEC3	t_vtx_min;			// _W̍ŏliŚj
	VEC3	t_vtx_max;			// _W̍őliŚj
	VEC3	t_vtx_cen;			// _W̒S_iŚj
	VEC3	vtx_min[P_MAX];		// _W̍ŏlip[cj
	VEC3	vtx_max[P_MAX];		// _W̍őlip[cj
	VEC3	vtx_cen[P_MAX];		// _W̒S_ip[cj
	int 	vtx_ct[P_MAX+1];	// _
	int 	face_ct[P_MAX+1];	// ʐ
	char 	name[P_MAX][LEN];	// p[c
	VEC3	*pv;				// _̍W
	VEC3	*pn;				// _̖@xNg
	float	*pb;				// _̏d
	float	*ptu,*ptv;			// _̃eNX`W
	int 	(*pf)[4];			// eʂ̒_ԍB_3̂Ƃ iv[3] = -1B
	bool	*psel;				// _̑ItOi0: I, 1: Ij
	bool	*pvis;				// _̉tOi0: s, 1: j
	int		flag_map[P_MAX];	// eNX`}bsÕtO
	float 	tex_scale[P_MAX][2];// eNX`}bv̕\{
	float 	tex_trans[P_MAX][2];// eNX`}bv̕sړ
	UINT	tex_dir[P_MAX];		// eNX`}bvKp̃f̕\
	float	mtrl[P_MAX][17];	// }eA
	char	tex_name[P_MAX][MAX_PATH];	// eNX`
	bool	flag_tex_all;		// eNX`̓KpΏہi0:p[c, 1:S)
	int		mt_ct;				// [V̐
	int		unit_ct;			// jbg
	int		anim_ct;			// Aj̐
	ANIMSET	as[M_MAX];			// Aj
	int		ax_flag[P_MAX];		// ]̎ށi0:ȂA1:Xw莲A2:xyzj
	VEC3	ax_v[P_MAX];		// ]̈ʒu
	int		ax_roll[P_MAX][3];	// ]̌Xpx
	char	unit_name[P_MAX][LEN];// jbg
	int		ax_b_dir[P_MAX];	// dݕt̕
	int		ax_b_prop[P_MAX];	// d݌W
	int		parent[P_MAX];		// p[cƃjbg̐eԍ
	int		mt_roll[M_MAX][P_MAX][3];	// jbg̉]px
	VEC3	mt_pos[M_MAX][P_MAX];		// jbg̕sړ
	bool	bSel;			// IݒtOi0: I, 1: Ij
	bool	bOneSide;		// ЖʃtOi0: , 1: Жʁj
	bool	bFreeAll;		// IԃtOi0: IĂ, 1: SĖIj
	UINT	zoom;			// ݂̕\{
	float	scale;			// ݑIĂp[c̊g嗦iZoom 100%j
	int		direction;		// ݌Ă
	Point	offset;			// _W摜ʒuɕϊƂ̃ItZbgl
	Rect	rc1;			// I`̍WƃTCYiZoom 100%j
	Rect	rc2;			// I`̍WƃTCYiZoom ݂̔{j
}MAIN,*LPMAIN;

typedef struct{
	Bitmap	*pBmp;			// f`悷rbg}bvIuWFNg
	int		wdh1,hgt1;		// 摜̉,			iZoom 100%j
	int		x,y,wdh2,hgt2;	// 摜XYW,,	iZoom ݂̔{j
}BMP,*LPBMP;

typedef struct{
	int 	t_vtx_ct;			// _
	int 	t_face_ct;			// ʐ
	int 	parts_ct;			// p[c
	VEC3	t_vtx_min;			// _W̍ŏliŚj
	VEC3	t_vtx_max;			// _W̍őliŚj
	VEC3	t_vtx_cen;			// _W̒S_iŚj
	VEC3	vtx_min[P_MAX];		// _W̍ŏlip[cj
	VEC3	vtx_max[P_MAX];		// _W̍őlip[cj
	VEC3	vtx_cen[P_MAX];		// _W̒S_ip[cj
	int 	vtx_ct[P_MAX+1];	// _
	int 	face_ct[P_MAX+1];	// ʐ
	int		parent[P_MAX];		// p[cƃjbg̐eԍ
	VEC3	*pv;				// _̍W
	VEC3	*pn;				// _̖@xNg
	float	*pb;				// _̏d
	float	*ptu,*ptv;			// _̃eNX`W
	int 	(*pf)[4];			// eʂ̒_ԍB_3̂Ƃ iv[3] = -1B
	bool	*psel;				// _̑ItOi0: I, 1: Ij
	bool	*pvis;				// _̉tOi0: s, 1: j
}UNDO,*LPUNDO;

typedef struct{
	int 	t_vtx_ct;			// _
	int 	t_face_ct;			// ʐ
	int 	vtx_ct[P_MAX+1];	// _
	int 	face_ct[P_MAX+1];	// ʐ
	VEC3	*pv;				// _̍W
	float	*pb;				// _̏d
	float	*ptu,*ptv;			// _̃eNX`W
	int 	(*pf)[4];			// eʂ̒_ԍB_3̂Ƃ iv[3] = -1B
	bool	*psel;				// _̑ItOi0: I, 1: Ij
}DIV,*LPDIV;

typedef struct{
	VEC3	v;					// eʂ̒_Wi[obt@
	int		v_idx;				// eʂ̒_W̔ԍi[obt@
	float	b;					// eʂ̒_̏d݂i[obt@
	float	tu,tv;				// eʂ̃eNX`Wi[obt@
}DIV2,*LPDIV2;

MAIN	g_m;
BMP		g_b;
UNDO	g_u;
int		Ids = 0;	// ݑIĂp[cԍ (0:S, 1`:p[cԍ+1)
bool	g_flag_blend = 0;		// uh tO
bool	g_flag_bin = 0;			// oCi t@C tO
bool	g_flag_translation = 0;	// sړtO
bool	g_flag_anim = 0;		// Aj tO

HINSTANCE	g_hInst      = NULL;
HMENU		g_hMenu      = NULL;
HWND		g_hWnd       = NULL;
HWND		g_hChild     = NULL;
HWND		g_hRebar_R   = NULL;
HWND		g_hTool_Main = NULL;
HWND		g_hTool_Zoom = NULL;
HWND		g_hStatic_Z  = NULL;
HWND		g_hEdit_Z    = NULL;
HWND		g_hSpin_Z    = NULL;
HWND		g_hSlider_Z  = NULL;
HWND		g_hList      = NULL;
HWND		g_hStatus    = NULL;
DWORD		g_dwCookie;

int 	TB_Bmp1[]      = {0,1,2};
int 	TB_Command1[]  = {IDM_SEL,IDM_ONESIDE,IDM_SEP};
char	TB_Text1[][30] = {"I/","/Ж","p[c"};
int 	TB_Command2[]  = {IDM_SIZEWIN,-1};
char	TB_Text2[][30] = {"EBhETCY",""};

char	g_tag[][TAG_LEN] = {"version","parts_count","motion_count","unit_count","total_vertex_count",
							"total_face_count","total_corner","total_center","texture_all",
							"parts_name","corner","center","material","texture_file",
							"texture_map_flag","texture_map_param","vertex_count",
							"face_count","vertices","normals","texture_map","faces",
							"unit_basis","parent","unit_angle","unit_translation","blend",
							"anim_count","anim_data"};

WNDPROC lpPreProcTool_Z;

LRESULT CALLBACK ProcWnd(HWND hWnd, UINT uMsg, WPARAM wParam, LPARAM lParam);
LRESULT CALLBACK ProcChild(HWND hWnd, UINT uMsg, WPARAM wParam, LPARAM lParam);
LRESULT CALLBACK ProcTool_Z (HWND hWnd, UINT uMsg, WPARAM wParam, LPARAM lParam);
int		CALLBACK ProcDivide (HWND hDlg, UINT uMsg, WPARAM wParam, LPARAM lParam);
void	Sel_Bttn(HWND *hBtn, int idx, int start, int end);
void	Resize(HWND hWnd);
void	Set_Center();
int		Get_Zoom();
void	Zoom_100();
void	Set_Pt4(Point *pt, int x1, int y1, int x2, int y2);
void	Set_Rect(Rect *rc, int x, int y, int wdh, int hgt);
void	Set_Rebar_V1(HWND hWnd);
void	Add_Main_Band(HWND hRebar);
void	Add_Zoom_Band(HWND hRebar);
bool	Load_Bmp();
float	Get_VtxNor(int idx);
PointF	Get_VtxPos(int idx);
void	AllFree_Vtx();
void	Line_Vtx(int idx);
void	One_Weight();
void	Select_Vtx();
bool	Separate_Parts();
void	Separate_Parts_Sub1(int p_idx, bool **psel_vtx, bool **psel_face);
void	Separate_Parts_Sub2(int p_idx, int f_idx, int v_ct, VEC3 *pv, int (*pf)[4], int ct);
void	Get_PartsCenter(int p_idx);
void	Get_BmpRectPos(int idx);
bool	Divide_Faces(int idx_4, int idx_3);
void	Divide_Faces_Sub1(int k, int i, LPDIV d);
void	Divide_Faces_Sub2(int k, int i, LPDIV d, int idx);
void	Divide_Faces_Sub3(int k, int i, LPDIV d);
void	Set_Divide_Vtx(int k, int i, LPDIV2 d2, int idx);
void	Set_Normals();
void	Set_Normals_Sub();
VEC3	Vec3_Vector(VEC3 start, VEC3 end);
VEC3	Vec3_Center(VEC3 a, VEC3 b);
bool	Vec3_Equal(VEC3 a, VEC3 b);
bool	Set_Undo();
bool	Undo();
void	Set_TopMenuState();
void	Set_SubMenuState(HMENU hMenuSub, int index);
void	Open_FileDlg(HWND hWnd);
bool	Save_FileDlg();
bool	Load(char *filename);
bool	Load_File_E(char *filename);
bool	Load_File_E_Bin(char *filename);
bool	Save_File_E(char *filename);
void	Fwrite_Tag(FILE *file2, int idx, int size);
bool	Save_File_E_Bin(char *filename);
void	Term();

int APIENTRY WinMain(HINSTANCE hInst, HINSTANCE hInstPrev, LPSTR lpCmdLine, int nCmdShow)
{
	// dNh~&R}hCn
	HWND hWnd = FindWindow(MYWNDCLASS, MYWNDTITLE);
	if(hWnd){
		SetForegroundWindow(hWnd);
		COPYDATASTRUCT cds;
		ZeroMemory(&cds, sizeof(cds));
		cds.cbData = strlen(__argv[1])+1;
		cds.lpData = __argv[1];
		SendMessage(hWnd, WM_COPYDATA, NULL, (LPARAM)&cds);
		return 0;
	}
	
	MSG 	   msg;
	WNDCLASSEX wc;
	
	g_hInst = hInst;
	
	// qEBhE
    ZeroMemory(&wc, sizeof(wc));
    wc.cbSize           = sizeof(WNDCLASSEX); 
    wc.lpfnWndProc      = (WNDPROC)ProcChild;
    wc.hInstance        = hInst;
	wc.hCursor          = LoadCursor(NULL, IDC_ARROW);
    wc.hbrBackground    = (HBRUSH) GetStockObject(WHITE_BRUSH);
    wc.lpszClassName    = MYCHILDCLASS;
    RegisterClassEx(&wc);
	
	// eEBhE
	ZeroMemory(&wc, sizeof(wc));
	wc.cbSize			= sizeof(WNDCLASSEX);
	wc.lpfnWndProc		= (WNDPROC)ProcWnd;
	wc.hInstance		= hInst;
	wc.hIcon			= LoadIcon(hInst, IDI_APPLICATION);
	wc.hCursor			= LoadCursor(NULL, MAKEINTRESOURCE(IDC_ARROW));
	wc.hbrBackground	= (HBRUSH)(COLOR_BTNFACE + 1);
	wc.lpszMenuName 	= NULL;
	wc.lpszClassName	= MYWNDCLASS;
	RegisterClassEx(&wc);
	
	g_hMenu = LoadMenu(hInst,MAKEINTRESOURCE(IDR_MENU1));
	
	hWnd = CreateWindowEx(WS_EX_ACCEPTFILES,
				MYWNDCLASS,
				MYWNDTITLE,
				WS_OVERLAPPEDWINDOW | WS_CLIPCHILDREN | WS_VISIBLE,
				CW_USEDEFAULT, CW_USEDEFAULT, CW_USEDEFAULT, CW_USEDEFAULT,
				NULL,
				g_hMenu,
				g_hInst,
				NULL);
	
	HACCEL hAC = LoadAccelerators(hInst, MAKEINTRESOURCE(IDR_ACCELERATOR1));
	HtmlHelp(hWnd, NULL, HH_INITIALIZE, g_dwCookie);
	
	while (GetMessage(&msg, NULL, 0, 0)) {
		if(TranslateAccelerator(hWnd, hAC, &msg))
			continue;
		if(HtmlHelp(hWnd, NULL, HH_PRETRANSLATEMESSAGE, (DWORD)&msg))
			continue;
		TranslateMessage(&msg);
		DispatchMessage(&msg);
	}
	return msg.wParam;
}// WinMain

LRESULT CALLBACK ProcWnd(HWND hWnd, UINT uMsg, WPARAM wParam, LPARAM lParam)
{
	switch (uMsg)
	{
	case WM_CREATE:
		GdiplusStartup(&gdiToken,&gdiSI,NULL);
		// RRg[̏
		INITCOMMONCONTROLSEX	icex;
		icex.dwSize = sizeof(INITCOMMONCONTROLSEX);
		icex.dwICC	= ICC_COOL_CLASSES | ICC_BAR_CLASSES | ICC_UPDOWN_CLASS;
		InitCommonControlsEx(&icex);
		// EBhE̒ǉ
		g_hWnd = hWnd;
		g_hStatus = Set_StatusBar(hWnd);			// Xe[^Xo[t
		g_hList = Set_List(hWnd, SetCsize(0,0,0,0), ID_LIST);// Xg{bNXt
		Set_Rebar_V1(hWnd);							// c^o[t
		g_hChild = Set_Child(hWnd, MYCHILDCLASS,	// qEBhEt
			WS_EX_CLIENTEDGE);
		Set_TopMenuState();
		return 0;
	case WM_SIZE:
		Resize(hWnd);
		if(g_b.pBmp){
			Load_Bmp();
		}
		if(__argc > 1){
			Load(__argv[1]);
			__argc = 0;
		}
		return 0;
	case WM_COPYDATA:
		COPYDATASTRUCT *pcds;
		pcds = (COPYDATASTRUCT*) lParam;
		Load((char*)pcds->lpData);
		return 0;
	case WM_DROPFILES:
		char	fname[MAX_PATH];
		HDROP	hDrop;
		hDrop = (HDROP) wParam;
		DragQueryFile(hDrop, 0, fname, sizeof(fname));
		Load(fname);
		DragFinish(hDrop);
		return 0;
	case WM_MENUSELECT:
		UINT index;
		index = (UINT) LOWORD(wParam);
		if(index != -1 && index < 1000){
			HMENU hMenuSub = GetSubMenu(g_hMenu, index);
			Set_SubMenuState(hMenuSub, index);
		}
		return 0;
	case WM_COMMAND:
		switch(LOWORD(wParam))
		{
		case IDM_OPEN:		// J
			Open_FileDlg(hWnd);
			return 0;
		case IDM_SAVEAS:	// Otĕۑ
			Save_FileDlg();
			break;
		case IDM_EXIT:		// I
			SendMessage(hWnd, WM_CLOSE, 0, 0);
			return 0;
		case IDM_UNDO:		// ɖ߂
			Undo();
			Ids = 0;
			SendMessage(g_hList, LB_SETCURSEL, Ids, 0);
			Load_Bmp();
			return 0;
		case IDM_SEP:		// p[c
			Set_Undo();
			Separate_Parts();
			Load_Bmp();
			return 0;
		case IDM_DIVIDE:	// ʕ
			Set_Undo();
			DialogBox(g_hInst, MAKEINTRESOURCE(IDD_DIALOG1), hWnd, ProcDivide);
			Set_Normals();	// @vZ
			Load_Bmp();
			return 0;
		case IDM_LINE_X:	// iXj
			Set_Undo();
			Line_Vtx(0);
			Load_Bmp();
			return 0;
		case IDM_LINE_Y:	// iYj
			Set_Undo();
			Line_Vtx(1);
			Load_Bmp();
			return 0;
		case IDM_LINE_Z:	// iZj
			Set_Undo();
			Line_Vtx(2);
			Load_Bmp();
			return 0;
		case IDM_WEIGHT:	// d݂1ɐݒ
			Set_Undo();
			One_Weight();
			AllFree_Vtx();
			return 0;
		case IDM_SELALL:	// SđI
			if(Ids == 0){	// S
				memset(g_m.psel, 1, sizeof(bool)*g_m.t_vtx_ct);
			}
			else if(Ids > 0){// p[c
				for(int k=0;k<g_m.parts_ct;k++){
					if(Ids == k + 1){
						for(int i=g_m.vtx_ct[k];i<g_m.vtx_ct[k+1];i++){
							g_m.psel[i] = 1;
						}
						break;
					}
				}
			}
			Load_Bmp();
			g_m.bFreeAll = 0;
			SendMessage(g_hTool_Main, TB_ENABLEBUTTON, IDM_SEP, MAKELONG(TRUE, 0));
			return 0;
		case IDM_FREEALL:	// SđI
			AllFree_Vtx();
			return 0;
		case IDM_SELREVERSE:// I𔽓]
			{
				bool flag = 1;
				for(int i=0;i<g_m.t_vtx_ct;i++){
					if(g_m.psel[i]){
						g_m.psel[i] = 0;
					}
					else{
						g_m.psel[i] = 1;
						flag = 0;
					}
				}
				Load_Bmp();
				g_m.bFreeAll = flag;
				SendMessage(g_hTool_Main, TB_ENABLEBUTTON, IDM_SEP, MAKELONG(FALSE, 0));
			}
			return 0;
		case IDM_SEL:		// I/
			g_m.bSel = Menu_State_Check(g_hMenu, IDM_SEL);
			if(g_m.bSel)
				SendMessage(g_hTool_Main, TB_CHECKBUTTON, IDM_SEL, TRUE);
			else
				SendMessage(g_hTool_Main, TB_CHECKBUTTON, IDM_SEL, FALSE);
			return 0;
		case IDM_ONESIDE:	// /Ж
			g_m.bOneSide = Menu_State_Check(g_hMenu, IDM_ONESIDE);
			if(g_m.bOneSide)
				SendMessage(g_hTool_Main, TB_CHECKBUTTON, IDM_ONESIDE, TRUE);
			else
				SendMessage(g_hTool_Main, TB_CHECKBUTTON, IDM_ONESIDE, FALSE);
			Load_Bmp();
			return 0;
		case IDM_FRONT:		// O
			g_m.direction = 0;
			Load_Bmp();
			return 0;
		case IDM_BACK:		// 
			g_m.direction = 1;
			Load_Bmp();
			return 0;
		case IDM_LEFT:		// 
			g_m.direction = 2;
			Load_Bmp();
			return 0;
		case IDM_RIGHT:		// E
			g_m.direction = 3;
			Load_Bmp();
			return 0;
		case IDM_TOP:		// 
			g_m.direction = 4;
			Load_Bmp();
			return 0;
		case IDM_BOTTOM:	// 
			g_m.direction = 5;
			Load_Bmp();
			return 0;
		case IDM_SIZEWIN:	// EBhETCYŕ\
			Zoom_100();
			return 0;
		case IDM_HELP:		// wv
			char	path[MAX_PATH],*p;
			GetModuleFileName(NULL,path,sizeof(path));
			p = strrchr(path,'\\');
			if(p)
				strcpy(p,"\\mparts.chm");
			HtmlHelp(NULL, path, HH_DISPLAY_TOPIC, 0);
			return 0;
		case IDM_ABOUT:	// o[W
			ShellAbout(hWnd, MYWNDTITLE, "MPARTS ver 1.21\tPGM", LoadIcon(g_hInst,MAKEINTRESOURCE(IDI_ICON1)));
			return 0;
		case ID_LIST:		// Xg{bNX
			switch(HIWORD(wParam))
			{
			case LBN_SELCHANGE:
				Ids = SendMessage(g_hList, LB_GETCURSEL, 0, 0);
				Load_Bmp();
				InvalidateRect(g_hChild, NULL, FALSE);
				return 0;
			}
		}
		break;
	case WM_NOTIFY:
		NMHDR *phdr;
		phdr = (NMHDR *)lParam;
		switch(phdr->code)
		{
		case RBN_LAYOUTCHANGED: // o[ohړƂ
		case RBN_ENDDRAG:		// o[oh̃hbOIƂ
			Resize(hWnd);
			InvalidateRect(g_hChild, NULL, FALSE);
			return 0;
		case RBN_AUTOSIZE:		// o[oh񂳂ꂽƂ
			if(((LPNMRBAUTOSIZE) lParam)->fChanged)
					Resize(hWnd);
			return 0;
		case TTN_NEEDTEXT:		// c[qg
			LPTOOLTIPTEXT lpttText;
			lpttText = (LPTOOLTIPTEXT)lParam;
			for(int i=0;i<sizeof(TB_Command1)/sizeof(int);i++){
				if((int)lpttText->hdr.idFrom == TB_Command1[i]){
					lpttText->lpszText = TB_Text1[i];
					return 0;
				}
			}
			return 0;
		}
		break;
	case WM_CLOSE:
		Term();
		DestroyWindow(hWnd);
		GdiplusShutdown(gdiToken);
		HtmlHelp(hWnd, NULL, HH_CLOSE_ALL, 0) ;
		HtmlHelp(hWnd, NULL, HH_UNINITIALIZE, g_dwCookie);
		PostQuitMessage(0);
		return 0;
	}
	return DefWindowProc(hWnd, uMsg, wParam, lParam);
}// ProcWnd

LRESULT CALLBACK ProcChild(HWND hWnd, UINT uMsg, WPARAM wParam, LPARAM lParam)
{
	static Point	pt_bgn = Point(-1, -1);	// `̊JnW
	static Point	pt_mm;					// ݂̃}EXʒu
	static RECT		rc_chld;				// qEBhẼNCAg̈
	
	switch (uMsg)
	{
	case WM_CREATE:
		Set_ScrollBar(g_hChild);
		return 0;
	case WM_SIZE:
		Set_Scroll_nPage(g_hChild);
		SetRect(&rc_chld, 0, 0, LOWORD(lParam), HIWORD(lParam));
		return 0;
	case WM_HSCROLL:
		Move_Scroll_H(g_hChild, wParam);
		return 0;
	case WM_VSCROLL:
		Move_Scroll_V(g_hChild, wParam);
		return 0;
	case WM_CONTEXTMENU:
		{
			POINT pos = {LOWORD(lParam), HIWORD(lParam)};
			HMENU hMenuSub = GetSubMenu(g_hMenu, 1);
			Set_SubMenuState(hMenuSub, 1);
			TrackPopupMenu(hMenuSub, TPM_LEFTALIGN | TPM_RIGHTBUTTON,
							pos.x, pos.y, 0, g_hWnd, NULL);
		}
		return 0;
	case WM_PAINT:
		{
			HDC				hDC;
			PAINTSTRUCT 	ps;
			hDC = BeginPaint(hWnd,&ps);
			Graphics	g(hDC);
			g.SetCompositingQuality(CompositingQualityHighSpeed);
			g.SetPixelOffsetMode(PixelOffsetModeHalf);
			g.SetInterpolationMode(InterpolationModeNearestNeighbor);
			if(g_b.pBmp){
				// NCAg̈TCỸrbg}bviƗprbg}bvj쐬
				Bitmap BmpCp(rc_chld.right, rc_chld.bottom, PixelFormat24bppRGB);
				Graphics gBmp(&BmpCp);
				gBmp.SetCompositingQuality(CompositingQualityHighSpeed);
				gBmp.SetPixelOffsetMode(PixelOffsetModeHalf);
				gBmp.SetInterpolationMode(InterpolationModeNearestNeighbor);
				// Ɨprbg}bvɕ`
				SolidBrush brush(Color(255,255,255,200));
				gBmp.FillRectangle(&brush, 0, 0, BmpCp.GetWidth(), BmpCp.GetHeight());
				// NbsO
				Rect rc(0, 0, BmpCp.GetWidth(), BmpCp.GetHeight());
				gBmp.SetClip(rc);
				// rbg}bv̕`
				gBmp.DrawImage(g_b.pBmp, -scr_x+g_b.x, -scr_y+g_b.y, g_b.wdh2, g_b.hgt2);
				// Ï̕`
				Pen pen_g(Color(255, 0, 255, 0), 1);
				Point pt[4];
				Set_Pt4(pt, -scr_x+g_m.rc2.X+1, -scr_y+g_m.rc2.Y+1, -scr_x+g_m.rc2.Width-1, -scr_y+g_m.rc2.Height-1);
				gBmp.DrawPolygon(&pen_g, pt, 4);
				// 摜̕`
				g.DrawImage(&BmpCp, 0, 0, BmpCp.GetWidth(), BmpCp.GetHeight());
			}
			EndPaint(hWnd,&ps);
		}
		return 0;
	case WM_LBUTTONDOWN:
		pt_bgn.X = LOWORD(lParam);
		pt_bgn.Y = HIWORD(lParam);
		ZeroMemory(&g_m.rc1, sizeof(g_m.rc1));
		ZeroMemory(&g_m.rc2, sizeof(g_m.rc2));
		if(GetCapture() != hWnd){
			SetCapture(hWnd);
		}
		return 0;
	case WM_LBUTTONUP:
		ReleaseCapture();
		if(!g_m.rc1.X && !g_m.rc1.Y && !g_m.rc1.Width && !g_m.rc1.Height){	// NbN̏ꍇ
			int z = g_m.zoom/100;
			Set_Rect(&g_m.rc2, pt_bgn.X-z+scr_x, pt_bgn.Y-z+scr_y, 
							pt_bgn.X+z+scr_x, pt_bgn.Y+z+scr_y);
			g_m.rc1 = Set_Rc_Sel2_Rec(g_m.rc2, g_b.x, g_b.y, g_m.zoom);
		}
		Select_Vtx();
		Load_Bmp();
		pt_bgn.X = -1;
		pt_bgn.Y = -1;
		ZeroMemory(&g_m.rc1, sizeof(g_m.rc1));
		ZeroMemory(&g_m.rc2, sizeof(g_m.rc2));
		return 0;
	case WM_MOUSEMOVE:
		if((wParam & MK_LBUTTON) && (pt_bgn.X != -1 && pt_bgn.Y != -1)){
			pt_mm.X = (int) LOWORD(lParam);
			pt_mm.Y = (int) HIWORD(lParam);
			Rect	clip;	// }EXNbv̕ƍ
			clip.X = g_b.x;
			clip.Y = g_b.y;
			g_b.wdh2 < rc_chld.right  ? clip.Width  = g_b.wdh2 : clip.Width  = rc_chld.right;
			g_b.hgt2 < rc_chld.bottom ? clip.Height = g_b.hgt2 : clip.Height = rc_chld.bottom;
			Rectangle_MouseMove(&g_m.rc1, &g_m.rc2, clip, &pt_bgn, pt_mm, wParam, g_m.zoom);
			InvalidateRect(g_hChild, NULL, FALSE);
		}
		return 0;
	}
	return DefWindowProc(hWnd, uMsg, wParam, lParam);
}// ProcChild

// c[o[ic^,Y[j̃vV[W
LRESULT CALLBACK ProcTool_Z(HWND hWnd, UINT uMsg, WPARAM wParam, LPARAM lParam)
{
	int 	dl;

	switch ( uMsg )
	{
	case WM_COMMAND:
		switch( LOWORD(wParam) )
		{
		case ID_EDITZ:
			switch( HIWORD(wParam) )
			{
			case EN_CHANGE:		// GfBbgҏWꂽ
				Set_Center();
				break;
			case EN_SETFOCUS:	// GfBbgɃJ[\\ꂽ
				SendMessage(g_hEdit_Z, WM_KILLFOCUS, 0, 0);
				break;
			}
			break;
		}
		break;
	case WM_NOTIFY:
		{
			NMHDR *phdr;
			phdr = (NMHDR *)lParam;
			switch(phdr->code)
			{
			case UDN_DELTAPOS:	// Xs̃{^ꂽƂ
				{
					LPNMUPDOWN	lpnmud = (LPNMUPDOWN) lParam;
					int 		pos = lpnmud->iPos;
					lpnmud->iDelta *= 100;
					dl = lpnmud->iPos + lpnmud->iDelta;
					SendMessage(g_hSlider_Z, TBM_SETPOS, TRUE, dl);
					SetFocus(g_hWnd);
				}
				break;
			case TTN_NEEDTEXT:	// c[qg
				{
					LPTOOLTIPTEXT lpttText = (LPTOOLTIPTEXT) lParam;
					for(int i=0;i<sizeof(TB_Command2)/sizeof(int);i++){
						if((int)lpttText->hdr.idFrom == TB_Command2[i]){
							lpttText->lpszText = TB_Text2[i];
							break;
						}
					}
				}
				break;
			}
		}
		break;
	case WM_VSCROLL:	// XC_[Ƃ
		dl = SendMessage(g_hSlider_Z, TBM_GETPOS, 0, 0);
		dl -= dl % 100;
		SendMessage(g_hSlider_Z, TBM_SETPOS, TRUE, dl);
		SendMessage(g_hSpin_Z, UDM_SETPOS, 0, MAKELONG(dl,0));
		SetFocus(g_hWnd);
	}
	return CallWindowProc(lpPreProcTool_Z, hWnd, uMsg, wParam, lParam);
}// ProcTool_Z

int CALLBACK ProcDivide(HWND hDlg, UINT uMsg, WPARAM wParam, LPARAM lParam)
{
	static HBITMAP	hBmp[13];
	static HWND		hBtn[13];
	static int		b_num1 = 0,b_num2 = 3;
	int				i;
	
	switch( uMsg )
	{
	case WM_INITDIALOG:
		{
		hBtn[0]  = GetDlgItem(hDlg,IDC_BUTTON1);
		hBtn[1]  = GetDlgItem(hDlg,IDC_BUTTON2);
		hBtn[2]  = GetDlgItem(hDlg,IDC_BUTTON3);
		hBtn[3]  = GetDlgItem(hDlg,IDC_BUTTON4);
		hBtn[4]  = GetDlgItem(hDlg,IDC_BUTTON5);
		hBtn[5]  = GetDlgItem(hDlg,IDC_BUTTON6);
		hBtn[6]  = GetDlgItem(hDlg,IDC_BUTTON7);
		hBtn[7]  = GetDlgItem(hDlg,IDC_BUTTON8);
		hBtn[8]  = GetDlgItem(hDlg,IDC_BUTTON9);
		hBtn[9]  = GetDlgItem(hDlg,IDC_BUTTON10);
		hBtn[10] = GetDlgItem(hDlg,IDC_BUTTON11);
		hBtn[11] = GetDlgItem(hDlg,IDC_BUTTON12);
		hBtn[12] = GetDlgItem(hDlg,IDC_BUTTON13);
		
		Sel_Bttn(hBtn, b_num1, 0, 2);
		Sel_Bttn(hBtn, b_num2, 3, 12);
		hBmp[0] = LoadBitmap(g_hInst,MAKEINTRESOURCE(IDB_01));
		SendMessage(hBtn[0],BM_SETIMAGE,(WPARAM)IMAGE_BITMAP,(LPARAM)hBmp[0]);
		hBmp[1] = LoadBitmap(g_hInst,MAKEINTRESOURCE(IDB_02));
		SendMessage(hBtn[1],BM_SETIMAGE,(WPARAM)IMAGE_BITMAP,(LPARAM)hBmp[1]);
		hBmp[2] = LoadBitmap(g_hInst,MAKEINTRESOURCE(IDB_03));
		SendMessage(hBtn[2],BM_SETIMAGE,(WPARAM)IMAGE_BITMAP,(LPARAM)hBmp[2]);
		hBmp[3] = LoadBitmap(g_hInst,MAKEINTRESOURCE(IDB_04));
		SendMessage(hBtn[3],BM_SETIMAGE,(WPARAM)IMAGE_BITMAP,(LPARAM)hBmp[3]);
		hBmp[4] = LoadBitmap(g_hInst,MAKEINTRESOURCE(IDB_05));
		SendMessage(hBtn[4],BM_SETIMAGE,(WPARAM)IMAGE_BITMAP,(LPARAM)hBmp[4]);
		hBmp[5] = LoadBitmap(g_hInst,MAKEINTRESOURCE(IDB_06));
		SendMessage(hBtn[5],BM_SETIMAGE,(WPARAM)IMAGE_BITMAP,(LPARAM)hBmp[5]);
		hBmp[6] = LoadBitmap(g_hInst,MAKEINTRESOURCE(IDB_07));
		SendMessage(hBtn[6],BM_SETIMAGE,(WPARAM)IMAGE_BITMAP,(LPARAM)hBmp[6]);
		hBmp[7] = LoadBitmap(g_hInst,MAKEINTRESOURCE(IDB_08));
		SendMessage(hBtn[7],BM_SETIMAGE,(WPARAM)IMAGE_BITMAP,(LPARAM)hBmp[7]);
		hBmp[8] = LoadBitmap(g_hInst,MAKEINTRESOURCE(IDB_09));
		SendMessage(hBtn[8],BM_SETIMAGE,(WPARAM)IMAGE_BITMAP,(LPARAM)hBmp[8]);
		hBmp[9] = LoadBitmap(g_hInst,MAKEINTRESOURCE(IDB_10));
		SendMessage(hBtn[9],BM_SETIMAGE,(WPARAM)IMAGE_BITMAP,(LPARAM)hBmp[9]);
		hBmp[10] = LoadBitmap(g_hInst,MAKEINTRESOURCE(IDB_11));
		SendMessage(hBtn[10],BM_SETIMAGE,(WPARAM)IMAGE_BITMAP,(LPARAM)hBmp[10]);
		hBmp[11] = LoadBitmap(g_hInst,MAKEINTRESOURCE(IDB_12));
		SendMessage(hBtn[11],BM_SETIMAGE,(WPARAM)IMAGE_BITMAP,(LPARAM)hBmp[11]);
		hBmp[12] = LoadBitmap(g_hInst,MAKEINTRESOURCE(IDB_13));
		SendMessage(hBtn[12],BM_SETIMAGE,(WPARAM)IMAGE_BITMAP,(LPARAM)hBmp[12]);
		}
		break;
	case WM_COMMAND:
		switch( wParam )
		{
		case IDC_BUTTON1 | (BN_CLICKED<<16):
			b_num1 = 0;
			Sel_Bttn(hBtn, 0, 0, 2);
			break;
		case IDC_BUTTON2 | (BN_CLICKED<<16):
			b_num1 = 1;
			Sel_Bttn(hBtn, 1, 0, 2);
			break;
		case IDC_BUTTON3 | (BN_CLICKED<<16):
			b_num1 = 2;
			Sel_Bttn(hBtn, 2, 0, 2);
			break;
		case IDC_BUTTON4 | (BN_CLICKED<<16):
			b_num2 = 3;
			Sel_Bttn(hBtn, 3, 3, 12);
			break;
		case IDC_BUTTON5 | (BN_CLICKED<<16):
			b_num2 = 4;
			Sel_Bttn(hBtn, 4, 3, 12);
			break;
		case IDC_BUTTON6 | (BN_CLICKED<<16):
			b_num2 = 5;
			Sel_Bttn(hBtn, 5, 3, 12);
			break;
		case IDC_BUTTON7 | (BN_CLICKED<<16):
			b_num2 = 6;
			Sel_Bttn(hBtn, 6, 3, 12);
			break;
		case IDC_BUTTON8 | (BN_CLICKED<<16):
			b_num2 = 7;
			Sel_Bttn(hBtn, 7, 3, 12);
			break;
		case IDC_BUTTON9 | (BN_CLICKED<<16):
			b_num2 = 8;
			Sel_Bttn(hBtn, 8, 3, 12);
			break;
		case IDC_BUTTON10 | (BN_CLICKED<<16):
			b_num2 = 9;
			Sel_Bttn(hBtn, 9, 3, 12);
			break;
		case IDC_BUTTON11 | (BN_CLICKED<<16):
			b_num2 = 10;
			Sel_Bttn(hBtn, 10, 3, 12);
			break;
		case IDC_BUTTON12 | (BN_CLICKED<<16):
			b_num2 = 11;
			Sel_Bttn(hBtn, 11, 3, 12);
			break;
		case IDC_BUTTON13 | (BN_CLICKED<<16):
			b_num2 = 12;
			Sel_Bttn(hBtn, 12, 3, 12);
			break;
		case IDOK:
			Divide_Faces(b_num1, b_num2);
			for(i=0;i<13;i++){
				DeleteObject(hBmp[i]);
			}
			EndDialog(hDlg,FALSE);
			break;
		case IDCANCEL:
			for(i=0;i<13;i++){
				DeleteObject(hBmp[i]);
			}
			EndDialog(hDlg,FALSE);
			break;
		}
		return FALSE;
	default:
		return FALSE;
	}
	return TRUE;
}// CALLBACK ProcDivide

// {^̏Ԑݒ
void Sel_Bttn(HWND *hBtn, int idx, int start, int end)
{
	for(int i=start;i<end;i++){
		SendMessage(hBtn[i],BM_SETSTATE,FALSE,0);
	}
	SendMessage(hBtn[idx],BM_SETSTATE, TRUE,0);
}// Sel_Bttn

// EBhETCYύXꂽƂ
void Resize(HWND hWnd)
{
	POINT	pt_r2,pt_l,pt_s;
	RECT	rc,rc_r2,rc_s;
	
	SendMessage(g_hChild, WM_SETREDRAW, FALSE, 0);
	
	// Xe[^Xo[̃TCYύX
	SendMessage(g_hStatus, WM_SIZE, 0, 0);
	GetWindowRect(g_hStatus, &rc_s);
	pt_s.y = rc_s.bottom - rc_s.top;	// Xe[^Xo[̍
	
	GetClientRect(hWnd, &rc);
	
	// Xg{bNX̃TCYύX
	pt_l.x = 128;						// Xg{bNX̕
	MoveWindow(g_hList, rc.right - pt_l.x, 0, pt_l.x, rc.bottom - pt_s.y, TRUE);
	
	// o[(E)̃TCYύX
	GetWindowRect(g_hRebar_R,&rc_r2);
	pt_r2.x = rc_r2.right - rc_r2.left;	// o[̕
	pt_r2.y = rc.bottom - pt_s.y;		// o[̍
	MoveWindow(g_hRebar_R, rc.right - pt_r2.x - pt_l.x, 0, pt_r2.x, pt_r2.y, TRUE);
	GetWindowRect(g_hRebar_R,&rc_r2);
	if(pt_r2.x != rc_r2.right - rc_r2.left){
		pt_r2.x = rc_r2.right - rc_r2.left;
		MoveWindow(g_hRebar_R, rc.right - pt_r2.x - pt_l.x, 0, pt_r2.x, pt_r2.y, TRUE);
	}
	
	SendMessage(g_hChild, WM_SETREDRAW, TRUE, 0);
	
	// qEBhẼTCYύX
	MoveWindow(g_hChild, 0, 0, rc.right - pt_r2.x - pt_l.x, rc.bottom - pt_s.y, TRUE);
	Set_Center();
}// Resize

// 摜𒆐Sɕ\
void Set_Center()
{
	RECT	rc;
	double	rat_x0,rat_y0;
	
	SendMessage(g_hChild, WM_SETREDRAW, FALSE, 0);	// qEBhE̕`s
	
	// Y[ύXÕy[WTCYɑ΂scroll boxʒu̔䗦
	if(si_h.nMax > (int)si_h.nPage){
		rat_x0 = (double)si_h.nPos / (si_h.nMax - si_h.nPage);
		if(rat_x0 < 0)
			rat_x0 = 0.0f;
		else if(rat_x0 > 1)
			rat_x0 = 1.0f;
	}
	else if(si_h.nMax < (int)si_h.nPage){
		rat_x0 = 0.5;
	}
	else{
		rat_x0 = 0;
	}
	if(si_v.nMax > (int)si_v.nPage){
		rat_y0 = (double)si_v.nPos / (si_v.nMax - si_v.nPage);
		if(rat_y0 < 0)
			rat_y0 = 0.0f;
		else if(rat_y0 > 1)
			rat_y0 = 1.0f;
	}
	else if(si_v.nMax < (int)si_v.nPage){
		rat_y0 = 0.5;
	}
	else{
		rat_y0 = 0;
	}
	
	Del_Scroll(g_hChild);
	
	// \TCYύX
	g_m.zoom = Get_Zoom();
	g_b.wdh2 = (g_b.wdh1 * g_m.zoom) / 100;
	g_b.hgt2 = (g_b.hgt1 * g_m.zoom) / 100;
	Set_Scroll_nMax(g_hChild, g_b.wdh2, g_b.hgt2);
	
	// scroll boẍʒuύX
	si_h.nPos = (int)(rat_x0 * (si_h.nMax - si_h.nPage));
	si_v.nPos = (int)(rat_y0 * (si_v.nMax - si_v.nPage));
	Set_Scroll_nMax(g_hChild, g_b.wdh2, g_b.hgt2);
	
	GetClientRect(g_hChild,&rc);
	
	// 摜EBhETCY菬ƂɁASɕ\
	g_b.x = 0;
	g_b.y = 0;
	if(rc.right > g_b.wdh2){
		g_b.x = (rc.right - g_b.wdh2) / 2;
		rat_x0 = 0.5f;
	}
	if(rc.bottom > g_b.hgt2){
		g_b.y = (rc.bottom - g_b.hgt2) / 2;
		rat_y0 = 0.5f;
	}
	
	// qEBhE̕`拖
	SendMessage(g_hChild, WM_SETREDRAW, TRUE, 0);
	
	// ĕ`
	InvalidateRect(g_hChild, NULL, FALSE);
}// Set_Center

// ݂̔{𓾂
int Get_Zoom()
{
	char	ss[8];
	int		mag;
	SendMessage(g_hEdit_Z, WM_GETTEXT, sizeof(ss), (LPARAM)ss);
	mag = atoi(ss);
	if(!mag)	mag = 1;
	return mag;
}// Get_Zoom

// \{100%ɂ
void Zoom_100()
{
	Del_Scroll(g_hChild);
	SendMessage(g_hSlider_Z, TBM_SETPOS, TRUE, 100);
	SendMessage(g_hEdit_Z, WM_SETTEXT, 0, (LPARAM) "100");
	g_b.wdh2 = g_b.wdh1;
	g_b.hgt2 = g_b.hgt1;
	Set_Scroll_nMax(g_hChild, g_b.wdh2, g_b.hgt2);
	InvalidateRect(g_hChild, NULL, FALSE);
}// Zoom_100

void Set_Pt4(Point *pt, int x1, int y1, int x2, int y2)
{
	pt[0] = Point(x1, y1);
	pt[1] = Point(x1, y2);
	pt[2] = Point(x2, y2);
	pt[3] = Point(x2, y1);
}// RectToPt4

void Set_Rect(Rect *rc, int x, int y, int wdh, int hgt)
{
	rc->X      = x;
	rc->Y      = y;
	rc->Width  = wdh;
	rc->Height = hgt;
}// Set_Rect

void Set_Rebar_V1(HWND hWnd)
{
	g_hRebar_R = Set_Rebar(hWnd, TRUE);
	Add_Main_Band(g_hRebar_R);
	Add_Zoom_Band(g_hRebar_R);
}// Set_Rebar_V1

// C̃ohǉ
void Add_Main_Band(HWND hRebar)
{
	// c[o[ic^j̍쐬
	g_hTool_Main = Set_Tool(GetParent(hRebar), TRUE);
	
	SendMessage(g_hTool_Main, TB_SETBITMAPSIZE, 0, (LPARAM) MAKELONG(32,30));
	
	TBBUTTON	tbb;
	int 		i,t_num,btn_hgt = 0;
	RECT		rc;
	
	ZeroMemory(&tbb,sizeof(TBBUTTON));
	t_num = sizeof(TB_Command1)/sizeof(int);
	for(i=0;i<t_num;i++){
		if(TB_Command1[i] == -1){
			tbb.fsStyle = 0;
			tbb.fsState = 0;
			tbb.iBitmap = -1;
		}
		else{
			tbb.fsStyle = TBSTYLE_AUTOSIZE;
			if(!i)
				tbb.fsStyle |= TBSTYLE_CHECK;
			tbb.fsState = TBSTATE_ENABLED;
			tbb.iString = -1;
			tbb.iBitmap = TB_Bmp1[i];
		}
		tbb.idCommand = TB_Command1[i];
		SendMessage(g_hTool_Main, TB_INSERTBUTTON, i, (LPARAM) &tbb);
		SendMessage(g_hTool_Main, TB_GETITEMRECT, i, (LPARAM) &rc);
		btn_hgt += (rc.bottom - rc.top);
	}
	
	// c[o[摜̒ǉiNo.0 `j
	TBADDBITMAP ab;
	ab.hInst = g_hInst;
	ab.nID	 = IDR_TOOLBAR1;
	SendMessage(g_hTool_Main, TB_ADDBITMAP, 4, (LPARAM)&ab);
	
	// c[o[ꂽo[ohǉ
	REBARBANDINFO	rbbi;
	ZeroMemory(&rbbi, sizeof(rbbi));
	rbbi.cbSize 	=	sizeof(REBARBANDINFO);
	rbbi.fMask		=	RBBIM_STYLE |
						RBBIM_CHILDSIZE | 
						RBBIM_CHILD;
	rbbi.hwndChild	=	g_hTool_Main;
	rbbi.fStyle		=	0;
	rbbi.cxMinChild =	btn_hgt;
	rbbi.cyMinChild =	rc.right - rc.left;
	
	SendMessage(hRebar, RB_INSERTBAND, (WPARAM)-1, (LPARAM)&rbbi);
	
}// Add_Main_Band

// Y[p̃o[ohǉ
void Add_Zoom_Band(HWND hRebar)
{
	REBARBANDINFO	rbbi;
	
	// c[o[ic^j̍쐬
	g_hTool_Zoom = Set_Tool(GetParent(hRebar), TRUE);
	
	// c[o[̃vV[W`
	lpPreProcTool_Z = (WNDPROC)SetWindowLong(g_hTool_Zoom, GWL_WNDPROC, (LONG)ProcTool_Z);
	
	SendMessage(g_hTool_Zoom, TB_SETBITMAPSIZE, 0, (LPARAM) MAKELONG(32,30));
	
	TBBUTTON	tbb;
	RECT		rc;
	int 		i,t_num;
	
	ZeroMemory(&tbb,sizeof(TBBUTTON));
	t_num = sizeof(TB_Command2)/sizeof(int);
	for(i=0;i<t_num;i++){
		if(TB_Command2[i] == -1){
			tbb.fsStyle = 0;
			tbb.fsState = 0;
			tbb.iBitmap = -1;
		}
		else{
			tbb.fsStyle = TBSTYLE_AUTOSIZE;
			tbb.fsState = TBSTATE_ENABLED;
			tbb.iString = -1;
			tbb.iBitmap = i;
		}
		tbb.idCommand = TB_Command2[i];
		SendMessage(g_hTool_Zoom, TB_INSERTBUTTON, i, (LPARAM) &tbb);
	}
	
	// c[o[摜̒ǉiNo.0 `j
	TBADDBITMAP ab;
	ab.hInst = g_hInst;
	ab.nID	 = IDR_TOOLBAR2;
	SendMessage(g_hTool_Zoom, TB_ADDBITMAP, 1, (LPARAM)&ab);
	
	int  b_size = SendMessage(g_hTool_Zoom, TB_GETBUTTONSIZE, 0, 0);
	
	RECT rc_st,rc_e,rc_sp,rc_sl;
	CSIZE sz_st,sz_e,sz_sp,sz_sl;
	// X^eBbN̍쐬
	SendMessage(g_hTool_Zoom, TB_GETITEMRECT, 1, (LPARAM) &rc);
	sz_st = SetCsize(rc.top+5, rc.left, 0, LOWORD(b_size));
	g_hStatic_Z = Set_Static(g_hTool_Zoom, sz_st, "ް", TRUE);
	GetWindowRect(g_hStatic_Z, &rc_st);
	// GfBbg̍쐬
	sz_e = SetCsize(rc.top+5+rc_st.bottom-rc_st.top, 0, 0, LOWORD(b_size) - 1);
	g_hEdit_Z = Set_Edit(g_hTool_Zoom, sz_e, ID_EDITZ, 1);
	GetWindowRect(g_hEdit_Z, &rc_e);
	// Xs̍쐬
	sz_sp = SetCsize(sz_e.x+rc_e.bottom-rc_e.top, 0, 0, LOWORD(b_size));
	g_hSpin_Z = Set_Spin(g_hTool_Zoom, sz_sp, TRUE);
	SendMessage(g_hSpin_Z, UDM_SETRANGE, 0, MAKELONG(1000,100));
	GetWindowRect(g_hSpin_Z, &rc_sp);
	// XC_[̍쐬
	sz_sl = SetCsize(sz_sp.x+rc_sp.bottom - rc_sp.top, 0, 150, LOWORD(b_size) - 1);
	g_hSlider_Z = Set_Slider(g_hTool_Zoom, sz_sl);
	SendMessage(g_hSlider_Z, TBM_SETTICFREQ, 100, 0);
	SendMessage(g_hSlider_Z, TBM_SETRANGE, TRUE, MAKELONG(100,1000));
	SendMessage(g_hSlider_Z, TBM_SETPOS, TRUE, 100);
	GetWindowRect(g_hSlider_Z, &rc_sl);
	
	ZeroMemory(&rbbi, sizeof(rbbi));
	rbbi.cbSize 	=	sizeof(REBARBANDINFO);
	rbbi.fMask		=	RBBIM_STYLE |
						RBBIM_CHILDSIZE | 
						RBBIM_CHILD;
	rbbi.hwndChild	=	g_hTool_Zoom;
	rbbi.fStyle 	=	0;
	rbbi.cxMinChild =	sz_sl.x + rc_sl.bottom - rc_sl.top;
	rbbi.cyMinChild =	LOWORD(b_size);
	
	SendMessage(hRebar, RB_INSERTBAND, (WPARAM)-1, (LPARAM)&rbbi);
}// Add_Zoom_Band

// frbg}bvɕ`悷
bool Load_Bmp()
{
	Get_BmpRectPos(Ids);
	SAFE_DELETE_OBJ(g_b.pBmp);
	g_b.pBmp = new Bitmap(g_b.wdh1, g_b.hgt1, PixelFormat32bppARGB);
	if(g_b.pBmp->GetLastStatus() != Ok){
		return 0;
	}
	Graphics	g(g_b.pBmp);
	// `𔒂œhԂ
	g.FillRectangle(&SolidBrush(Color(255,255,255,200)), 0, 0, g_b.wdh1, g_b.hgt1);
	// f̕`
	int			i,j,k,idx,f_n;
	PointF		v;
	Point		pt_p[4];
	Pen			pen_p(Color(255, 100, 100, 100), 1);
	float		visible;	// tO
	
	for(k=0;k<g_m.parts_ct;k++){
		if(Ids == 0 || Ids == k + 1){	// Ids: (0:S, k+1:p[c)
			ZeroMemory(&g_m.pvis[g_m.vtx_ct[k]], sizeof(bool)*(g_m.vtx_ct[k+1]-g_m.vtx_ct[k]));
			for(i=g_m.face_ct[k];i<g_m.face_ct[k+1];i++){
				visible = 0;
				for(j=0;j<4;j++){
					if(j != 3 || g_m.pf[i][3] != -1){
						idx = g_m.pf[i][j] + g_m.vtx_ct[k];
						v = Get_VtxPos(idx);
						pt_p[j].X = g_m.offset.X + (int)(v.X * g_m.scale);
						pt_p[j].Y = g_m.offset.Y - (int)(v.Y * g_m.scale);
						if(g_m.bOneSide){	// Жʕ`̂Ƃ
							visible += Get_VtxNor(idx);
						}
					}
				}
				f_n = 4;
				if(g_m.pf[i][3] == -1)
					f_n = 3;
				if(!g_m.bOneSide || visible >= 0){
					// ʂ̕`
					g.DrawPolygon(&pen_p, pt_p, f_n);
					// _̉茋ʂOϐɓ
					for(j=0;j<4;j++){
						if(j != 3 || g_m.pf[i][3] != -1){
							idx = g_m.pf[i][j] + g_m.vtx_ct[k];
							g_m.pvis[idx] = true;
						}
					}
				}
			}
		}
	}
	SolidBrush		brush_black(Color(255, 0, 0, 0));
	SolidBrush		brush_red(Color(255, 255, 0, 0));
	for(k=0;k<g_m.parts_ct;k++){
		if(Ids == 0 || Ids == k + 1){
			for(i=g_m.vtx_ct[k];i<g_m.vtx_ct[k+1];i++){
				if(!g_m.bOneSide || g_m.pvis[i]){
					v = Get_VtxPos(i);
					if(g_m.psel[i]){
						g.FillRectangle(&brush_red, g_m.offset.X + (int)(v.X * g_m.scale) - 1,
											  g_m.offset.Y - (int)(v.Y * g_m.scale) - 1, 3, 3);
					}
					else{
						g.FillRectangle(&brush_black, g_m.offset.X + (int)(v.X * g_m.scale) - 1,
											  g_m.offset.Y - (int)(v.Y * g_m.scale) - 1, 3, 3);
					}
				}
			}
		}
	}
	if(g.GetLastStatus() != Ok){
		return 0;
	}
	Set_Center();
	return 1;
}// Load_Bmp

// \Ƃ̉p_@Ԃ
float Get_VtxNor(int idx)
{
	float val;
	
	switch(g_m.direction)
	{
	case 0:	// O
		val = - g_m.pn[idx].z;
		break;
	case 1:	// 
		return (g_m.pn[idx].z);
		val = g_m.pn[idx].z;
		break;
	case 2:	// 
		val = - g_m.pn[idx].x;
		break;
	case 3:	// E
		val = g_m.pn[idx].x;
		break;
	case 4:	// 
		val = g_m.pn[idx].y;
		break;
	case 5:	// 
		val = - g_m.pn[idx].y;
		break;
	}
	return val;
}// Get_VtxNor

// \Ƃ̒_WԂ
PointF Get_VtxPos(int idx)
{
	PointF ptf;
	
	switch(g_m.direction)
	{
	case 0:	// O
		ptf.X = g_m.pv[idx].x;
		ptf.Y = g_m.pv[idx].y;
		break;
	case 1:	// 
		ptf.X = - g_m.pv[idx].x;
		ptf.Y = g_m.pv[idx].y;
		break;
	case 2:	// 
		ptf.X = g_m.pv[idx].z;
		ptf.Y = g_m.pv[idx].y;
		break;
	case 3:	// E
		ptf.X = - g_m.pv[idx].z;
		ptf.Y = g_m.pv[idx].y;
		break;
	case 4:	// 
		ptf.X = g_m.pv[idx].x;
		ptf.Y = - g_m.pv[idx].z;
		break;
	case 5:	// 
		ptf.X = g_m.pv[idx].x;
		ptf.Y = g_m.pv[idx].z;
		break;
	}
	return ptf;
}// Get_VtxPos

// SđI
void AllFree_Vtx()
{
	ZeroMemory(g_m.psel, sizeof(bool)*g_m.t_vtx_ct);
	Load_Bmp();
	g_m.bFreeAll = 1;
	SendMessage(g_hTool_Main, TB_ENABLEBUTTON, IDM_SEP, MAKELONG(FALSE, 0));
}// AllFree_Vtx

// Iꂽ_Ww肳ꂽɉđ
// idx: 鎲̕i0: X, 1: Y, 2: Zj
void Line_Vtx(int idx)
{
	int		i,ct;
	double	ave;
	
	ave = 0;
	ct = 0;
	for(i=0;i<g_m.t_vtx_ct;i++){
		if(g_m.psel[i]){
			switch (idx)
			{
			case 0:		// X
				ave += g_m.pv[i].x;
				break;
			case 1:		// Y
				ave += g_m.pv[i].y;
				break;
			case 2:		// Z
				ave += g_m.pv[i].z;
				break;
			}
			ct ++;
		}
	}
	
	ave /= ct;
	
	for(i=0;i<g_m.t_vtx_ct;i++){
		if(g_m.psel[i]){
			switch (idx)
			{
			case 0:		// X
				g_m.pv[i].x = (float) ave;
				break;
			case 1:		// Y
				g_m.pv[i].y = (float) ave;
				break;
			case 2:		// Z
				g_m.pv[i].z = (float) ave;
				break;
			}
		}
	}
}// Line_Vtx

// Iꂽ_̏d݂1ɐݒ肷
void One_Weight()
{
	for(int i=0;i<g_m.t_vtx_ct;i++){
		if(g_m.psel[i]){
			g_m.pb[i] = 1.0f;
		}
	}
}// One_Weight

// _I
void Select_Vtx()
{
	int		i,k;
	PointF	v1;
	Point	v2;
	
	for(k=0;k<g_m.parts_ct;k++){
		if(Ids == 0 || Ids == k + 1){
			for(i=g_m.vtx_ct[k];i<g_m.vtx_ct[k+1];i++){
				v1 = Get_VtxPos(i);
				v2.X = g_m.offset.X + (int)(v1.X * g_m.scale);
				v2.Y = g_m.offset.Y - (int)(v1.Y * g_m.scale);
				if( v2.X >= g_m.rc1.X && v2.X <= g_m.rc1.Width &&
					v2.Y >= g_m.rc1.Y && v2.Y <= g_m.rc1.Height ){
					if(!g_m.bSel)
						g_m.psel[i] = true;
					else
						g_m.psel[i] = false;
				}
			}
		}
	}
	
	g_m.bFreeAll = 1;
	SendMessage(g_hTool_Main, TB_ENABLEBUTTON, IDM_SEP, MAKELONG(FALSE, 0));
	for(i=0;i<g_m.t_vtx_ct;i++){
		if(g_m.psel[i]){
			g_m.bFreeAll = 0;
			SendMessage(g_hTool_Main, TB_ENABLEBUTTON, IDM_SEP, MAKELONG(TRUE, 0));
			break;
		}
	}
}// Select_Vtx

// p[c𕪊
bool Separate_Parts()
{
	if(g_m.parts_ct + g_m.unit_ct == P_MAX - 1){
		MessageBox(g_hWnd,"p[cɒB܂B\n͕ł܂B",MYWNDTITLE,0);
	}
	if(g_m.parts_ct + g_m.unit_ct > P_MAX - 1){
		MessageBox(g_hWnd,"p[cɒB܂B\nł܂B",MYWNDTITLE,0);
		return 0;
	}
	
	int		i,j,k,idx;
	int		p_idx = -1;				// ؂p[c̔ԍ
	bool	flag1,flag2;
	bool	*psel_vtx[2];			// I𒸓_̃tOi0:؂鑤, 1:؂鑤j
	bool	*psel_face[2];			// Iʂ̃tO@i0:؂鑤, 1:؂鑤j
	
	for(i=0;i<2;i++){
		psel_vtx[i]  = new bool [g_m.t_vtx_ct];
		psel_face[i] = new bool [g_m.t_face_ct];
		ZeroMemory(psel_vtx[i],  sizeof(bool) * g_m.t_vtx_ct);
		ZeroMemory(psel_face[i], sizeof(bool) * g_m.t_face_ct);
	}
	// ꂼ̃tO߂
	flag2 = 0;
	for(k=0;k<g_m.parts_ct;k++){
		for(i=g_m.face_ct[k];i<g_m.face_ct[k+1];i++){
			flag1 = 0;
			for(j=0;j<4;j++){
				if(j != 3 || g_m.pf[i][3] != -1){
					idx = g_m.pf[i][j] + g_m.vtx_ct[k];
					if(!g_m.psel[idx]){
						flag1 = 1;
						break;
					}
				}
			}
			if(!flag1){	// ؂鑤
				psel_face[0][i] = true;
				for(j=0;j<4;j++){
					if(j != 3 || g_m.pf[i][3] != -1){
						idx = g_m.pf[i][j] + g_m.vtx_ct[k];
						psel_vtx[0][idx] = true;
						flag2 = 1;
					}
				}
			}
			else{		// ؂鑤
				psel_face[1][i] = true;
				for(j=0;j<4;j++){
					if(j != 3 || g_m.pf[i][3] != -1){
						idx = g_m.pf[i][j] + g_m.vtx_ct[k];
						psel_vtx[1][idx] = true;
					}
				}
			}
		}
		if(flag2){
			p_idx = k;
			break;
		}
	}
	if(p_idx >= 0){
		Separate_Parts_Sub1(p_idx, psel_vtx, psel_face);
	}
	for(i=0;i<2;i++){
		SAFE_DELETE_ARRAY(psel_vtx[i]);
		SAFE_DELETE_ARRAY(psel_face[i]);
	}
	if(p_idx < 0){
		MessageBox(g_hWnd,"IĂ钸_͂܂",MYWNDTITLE,0);
		return 0;
	}
	return 1;
}// Separate_Parts

void Separate_Parts_Sub1(int p_idx, bool **psel_vtx, bool **psel_face)
{
	int	i,idx;
	int	vtx_ct[2],face_ct[2];	// I𒸓_Eʂ̐i0: ؂鑤, 1:؂鑤j
	
	// ꂼ̒_߂
	vtx_ct[0] = vtx_ct[1] = 0;
	for(i=g_m.vtx_ct[p_idx];i<g_m.vtx_ct[p_idx+1];i++){
		if(psel_vtx[0][i])
			vtx_ct[0] ++;
		if(psel_vtx[1][i])
			vtx_ct[1] ++;
	}
	// ꂼ̖ʐ߂
	face_ct[0] = face_ct[1] = 0;
	for(i=g_m.face_ct[p_idx];i<g_m.face_ct[p_idx+1];i++){
		if(psel_face[0][i])
			face_ct[0] ++;
		if(psel_face[1][i])
			face_ct[1] ++;
	}
	
	VEC3	*pv[2];				// _̍W
	VEC3	*pn[2];				// _̖@xNg
	float	*pb[2];				// _̏d
	float	*ptu[2],*ptv[2];	// _̃eNX`W
	int 	(*pf[2])[4];		// eʂ̒_ԍB_3̂Ƃ iv[3] = -1B
	int		ct[2];
	
	for(i=0;i<2;i++){
		pv[i]   = new VEC3  [vtx_ct[i]];
		pn[i]   = new VEC3  [vtx_ct[i]];
		pb[i]   = new float [vtx_ct[i]];
		ptu[i]  = new float [vtx_ct[i]];
		ptv[i]  = new float [vtx_ct[i]];
		pf[i]   = new int   [face_ct[i]][4];
		ZeroMemory(pv[i],   sizeof(VEC3)   * vtx_ct[i]);
		ZeroMemory(pn[i],   sizeof(VEC3)   * vtx_ct[i]);
		ZeroMemory(pb[i],   sizeof(float)  * vtx_ct[i]);
		ZeroMemory(ptu[i],  sizeof(float)  * vtx_ct[i]);
		ZeroMemory(ptv[i],  sizeof(float)  * vtx_ct[i]);
		ZeroMemory(pf[i],   sizeof(int[4]) * face_ct[i]);
	}
	// _ݒ
	ct[0] = ct[1] = 0;
	for(i=g_m.vtx_ct[p_idx];i<g_m.vtx_ct[p_idx+1];i++){
		if(psel_vtx[0][i]){
			pv[0][ct[0]]  = g_m.pv[i];
			pn[0][ct[0]]  = g_m.pn[i];
			pb[0][ct[0]]  = g_m.pb[i];
			ptu[0][ct[0]] = g_m.ptu[i];
			ptv[0][ct[0]] = g_m.ptv[i];
			ct[0] ++;
		}
		if(psel_vtx[1][i]){
			pv[1][ct[1]]  = g_m.pv[i];
			pn[1][ct[1]]  = g_m.pn[i];
			pb[1][ct[1]]  = g_m.pb[i];
			ptu[1][ct[1]] = g_m.ptu[i];
			ptv[1][ct[1]] = g_m.ptv[i];
			ct[1] ++;
		}
	}
	// ʂݒ
	ct[0] = ct[1] = 0;
	for(i=g_m.face_ct[p_idx];i<g_m.face_ct[p_idx+1];i++){
		if(psel_face[0][i]){
			Separate_Parts_Sub2(p_idx, i, vtx_ct[0], pv[0], pf[0], ct[0]);
			ct[0] ++;
		}
		if(psel_face[1][i]){
			Separate_Parts_Sub2(p_idx, i, vtx_ct[1], pv[1], pf[1], ct[1]);
			ct[1] ++;
		}
	}
	// ؂ꂽp[c̓eύX
	memcpy(&g_m.pv[g_m.vtx_ct[p_idx]],   pv[1],  sizeof(VEC3)  *vtx_ct[1]);
	memcpy(&g_m.pn[g_m.vtx_ct[p_idx]],   pn[1],  sizeof(VEC3)  *vtx_ct[1]);
	memcpy(&g_m.pb[g_m.vtx_ct[p_idx]],   pb[1],  sizeof(float) *vtx_ct[1]);
	memcpy(&g_m.ptu[g_m.vtx_ct[p_idx]],  ptu[1], sizeof(float) *vtx_ct[1]);
	memcpy(&g_m.ptv[g_m.vtx_ct[p_idx]],  ptv[1], sizeof(float) *vtx_ct[1]);
	ZeroMemory(&g_m.psel[g_m.vtx_ct[p_idx]], sizeof(bool)*vtx_ct[1]);
	ZeroMemory(&g_m.pvis[g_m.vtx_ct[p_idx]], sizeof(bool)*vtx_ct[1]);
	memcpy(&g_m.pf[g_m.face_ct[p_idx]],  pf[1],  sizeof(int[4])*face_ct[1]);
	memmove(&g_m.pv[g_m.vtx_ct[p_idx]+vtx_ct[1]],   &g_m.pv[g_m.vtx_ct[p_idx+1]],   sizeof(VEC3)  *(g_m.t_vtx_ct-g_m.vtx_ct[p_idx+1]));
	memmove(&g_m.pn[g_m.vtx_ct[p_idx]+vtx_ct[1]],   &g_m.pn[g_m.vtx_ct[p_idx+1]],   sizeof(VEC3)  *(g_m.t_vtx_ct-g_m.vtx_ct[p_idx+1]));
	memmove(&g_m.pb[g_m.vtx_ct[p_idx]+vtx_ct[1]],   &g_m.pb[g_m.vtx_ct[p_idx+1]],   sizeof(float) *(g_m.t_vtx_ct-g_m.vtx_ct[p_idx+1]));
	memmove(&g_m.ptu[g_m.vtx_ct[p_idx]+vtx_ct[1]],  &g_m.ptu[g_m.vtx_ct[p_idx+1]],  sizeof(float) *(g_m.t_vtx_ct-g_m.vtx_ct[p_idx+1]));
	memmove(&g_m.ptv[g_m.vtx_ct[p_idx]+vtx_ct[1]],  &g_m.ptv[g_m.vtx_ct[p_idx+1]],  sizeof(float) *(g_m.t_vtx_ct-g_m.vtx_ct[p_idx+1]));
	memmove(&g_m.psel[g_m.vtx_ct[p_idx]+vtx_ct[1]], &g_m.psel[g_m.vtx_ct[p_idx+1]], sizeof(bool)  *(g_m.t_vtx_ct-g_m.vtx_ct[p_idx+1]));
	memmove(&g_m.pvis[g_m.vtx_ct[p_idx]+vtx_ct[1]], &g_m.pvis[g_m.vtx_ct[p_idx+1]], sizeof(bool)  *(g_m.t_vtx_ct-g_m.vtx_ct[p_idx+1]));
	memmove(&g_m.pf[g_m.face_ct[p_idx]+face_ct[1]], &g_m.pf[g_m.face_ct[p_idx+1]],  sizeof(int[4])*(g_m.t_face_ct-g_m.face_ct[p_idx+1]));
	int size_v = (g_m.vtx_ct[p_idx+1]-g_m.vtx_ct[p_idx])-vtx_ct[1];
	int size_f = (g_m.face_ct[p_idx+1]-g_m.face_ct[p_idx])-face_ct[1];
	for(i=p_idx;i<g_m.parts_ct;i++){
		g_m.vtx_ct[i+1]  -= size_v;
		g_m.face_ct[i+1] -= size_f;
	}
	Get_PartsCenter(p_idx);
	// ؂p[cǉ
	g_m.parts_ct ++;
	g_m.t_vtx_ct  += (vtx_ct[0]-size_v);
	g_m.t_face_ct += (face_ct[0]-size_f);
	g_m.pv   = (VEC3*) realloc(g_m.pv,    sizeof(VEC3)  *g_m.t_vtx_ct);
	g_m.pn   = (VEC3*) realloc(g_m.pn,    sizeof(VEC3)  *g_m.t_vtx_ct);
	g_m.pb   = (float*)realloc(g_m.pb,    sizeof(float) *g_m.t_vtx_ct);
	g_m.ptu  = (float*)realloc(g_m.ptu,   sizeof(float) *g_m.t_vtx_ct);
	g_m.ptv  = (float*)realloc(g_m.ptv,   sizeof(float) *g_m.t_vtx_ct);
	g_m.psel = (bool*) realloc(g_m.psel,  sizeof(bool)  *g_m.t_vtx_ct);
	g_m.pvis = (bool*) realloc(g_m.pvis,  sizeof(bool)  *g_m.t_vtx_ct);
	g_m.pf   = (int(*)[4])realloc(g_m.pf, sizeof(int[4])*g_m.t_face_ct);
	idx = g_m.parts_ct-1;
	memcpy(&g_m.pv[g_m.vtx_ct[idx]],  pv[0],  sizeof(VEC3)  *vtx_ct[0]);
	memcpy(&g_m.pn[g_m.vtx_ct[idx]],  pn[0],  sizeof(VEC3)  *vtx_ct[0]);
	memcpy(&g_m.pb[g_m.vtx_ct[idx]],  pb[0],  sizeof(float) *vtx_ct[0]);
	memcpy(&g_m.ptu[g_m.vtx_ct[idx]], ptu[0], sizeof(float) *vtx_ct[0]);
	memcpy(&g_m.ptv[g_m.vtx_ct[idx]], ptv[0], sizeof(float) *vtx_ct[0]);
	ZeroMemory(&g_m.psel[g_m.vtx_ct[idx]], sizeof(bool)*vtx_ct[0]);
	ZeroMemory(&g_m.pvis[g_m.vtx_ct[idx]], sizeof(bool)*vtx_ct[0]);
	memcpy(&g_m.pf[g_m.face_ct[idx]], pf[0],  sizeof(int[4])*face_ct[0]);
	g_m.vtx_ct[idx+1]  = g_m.vtx_ct[idx] + vtx_ct[0];
	g_m.face_ct[idx+1] = g_m.face_ct[idx] + face_ct[0];
	strcpy(g_m.name[idx], "no-name");
	g_m.flag_map[idx] = g_m.flag_map[p_idx];
	memcpy(g_m.mtrl[idx], g_m.mtrl[p_idx], sizeof(float[17]));
	strcpy(g_m.tex_name[idx], g_m.tex_name[p_idx]);
	if(g_m.unit_ct > 0){
		for(i=idx+g_m.unit_ct-1;i>=idx;i--){
			if(g_m.parent[i] != 0)
				g_m.parent[i+1] = g_m.parent[i] + 1;
			else
				g_m.parent[i+1] = g_m.parent[i];
		}
		g_m.parent[idx] = g_m.parent[p_idx];
		for(i=0;i<g_m.parts_ct;i++){
			g_m.parent[i] ++;
		}
	}
	Get_PartsCenter(idx);
	for(i=0;i<2;i++){
		SAFE_DELETE_ARRAY(pv[i]);
		SAFE_DELETE_ARRAY(pn[i]);
		SAFE_DELETE_ARRAY(pb[i]);
		SAFE_DELETE_ARRAY(ptu[i]);
		SAFE_DELETE_ARRAY(ptv[i]);
		SAFE_DELETE_ARRAY(pf[i]);
	}
	SendMessage(g_hList, LB_ADDSTRING, 0, (LPARAM) g_m.name[g_m.parts_ct-1]);
}// Separate_Parts_Sub1

void Separate_Parts_Sub2(int p_idx, int f_idx, int v_ct, VEC3 *pv, int (*pf)[4], int ct)
{
	int j,k,idx;
	for(j=0;j<4;j++){
		if(j != 3 || g_m.pf[f_idx][3] != -1){
			idx = g_m.pf[f_idx][j] + g_m.vtx_ct[p_idx];
			for(k=0;k<v_ct;k++){
				if( g_m.pv[idx].x == pv[k].x &&
					g_m.pv[idx].y == pv[k].y &&
					g_m.pv[idx].z == pv[k].z )
				{
					pf[ct][j] = k;
					break;
				}
			}
		}
		else{
			pf[ct][3] = -1;
		}
	}
}// Separate_Parts_Sub2

// p[c̃oEfBO{bNXƒS_߂ĊOϐɓ
// p_idx: p[cԍ
void Get_PartsCenter(int p_idx)
{
	int i,v_ct1,v_ct2;
	// p[c̃oEfBO{bNX̍ŏlƍől
	v_ct1 = g_m.vtx_ct[p_idx];
	v_ct2 = g_m.vtx_ct[p_idx+1];
	g_m.vtx_min[p_idx].x = g_m.pv[v_ct1].x;
	g_m.vtx_max[p_idx].x = g_m.pv[v_ct1].x;
	g_m.vtx_min[p_idx].y = g_m.pv[v_ct1].y;
	g_m.vtx_max[p_idx].y = g_m.pv[v_ct1].y;
	g_m.vtx_min[p_idx].z = g_m.pv[v_ct1].z;
	g_m.vtx_max[p_idx].z = g_m.pv[v_ct1].z;
	for(i=v_ct1+1;i<v_ct2;i++){
		if(g_m.vtx_min[p_idx].x > g_m.pv[i].x)
			g_m.vtx_min[p_idx].x = g_m.pv[i].x;
		if(g_m.vtx_max[p_idx].x < g_m.pv[i].x)
			g_m.vtx_max[p_idx].x = g_m.pv[i].x;
		if(g_m.vtx_min[p_idx].y > g_m.pv[i].y)
			g_m.vtx_min[p_idx].y = g_m.pv[i].y;
		if(g_m.vtx_max[p_idx].y < g_m.pv[i].y)
			g_m.vtx_max[p_idx].y = g_m.pv[i].y;
		if(g_m.vtx_min[p_idx].z > g_m.pv[i].z)
			g_m.vtx_min[p_idx].z = g_m.pv[i].z;
		if(g_m.vtx_max[p_idx].z < g_m.pv[i].z)
			g_m.vtx_max[p_idx].z = g_m.pv[i].z;
	}
	
	// p[c̒SW
	g_m.vtx_cen[p_idx].x = (g_m.vtx_max[p_idx].x + g_m.vtx_min[p_idx].x) / 2;
	g_m.vtx_cen[p_idx].y = (g_m.vtx_max[p_idx].y + g_m.vtx_min[p_idx].y) / 2;
	g_m.vtx_cen[p_idx].z = (g_m.vtx_max[p_idx].z + g_m.vtx_min[p_idx].z) / 2;
}// Get_PartsCenter

// p[cƂ̉摜TCYƃItZbg擾
// idx:		p[cԍ + 1@i0 ͑Śj
void Get_BmpRectPos(int idx)
{
	RECT	rc;
	float	scale_x,scale_y;
	PointF	v_min,v_max,v_cen;
	
	GetClientRect(g_hChild, &rc);
	rc.right  -= 30;
	rc.bottom -= 30;
	
	switch(g_m.direction)
	{
	case 0:	// O
	case 1:	// 
		if(!idx){
			v_min.X = g_m.t_vtx_min.x;
			v_min.Y = g_m.t_vtx_min.y;
			v_max.X = g_m.t_vtx_max.x;
			v_max.Y = g_m.t_vtx_max.y;
			v_cen.X = g_m.t_vtx_cen.x;
			v_cen.Y = g_m.t_vtx_cen.y;
		}
		else{
			v_min.X = g_m.vtx_min[idx-1].x;
			v_min.Y = g_m.vtx_min[idx-1].y;
			v_max.X = g_m.vtx_max[idx-1].x;
			v_max.Y = g_m.vtx_max[idx-1].y;
			v_cen.X = g_m.vtx_cen[idx-1].x;
			v_cen.Y = g_m.vtx_cen[idx-1].y;
		}
		break;
	case 2:	// 
	case 3:	// E
		if(!idx){
			v_min.X = g_m.t_vtx_min.z;
			v_min.Y = g_m.t_vtx_min.y;
			v_max.X = g_m.t_vtx_max.z;
			v_max.Y = g_m.t_vtx_max.y;
			v_cen.X = g_m.t_vtx_cen.z;
			v_cen.Y = g_m.t_vtx_cen.y;
		}
		else{
			v_min.X = g_m.vtx_min[idx-1].z;
			v_min.Y = g_m.vtx_min[idx-1].y;
			v_max.X = g_m.vtx_max[idx-1].z;
			v_max.Y = g_m.vtx_max[idx-1].y;
			v_cen.X = g_m.vtx_cen[idx-1].z;
			v_cen.Y = g_m.vtx_cen[idx-1].y;
		}
		break;
	case 4:	// 
	case 5:	// 
		if(!idx){
			v_min.X = g_m.t_vtx_min.x;
			v_min.Y = g_m.t_vtx_min.z;
			v_max.X = g_m.t_vtx_max.x;
			v_max.Y = g_m.t_vtx_max.z;
			v_cen.X = g_m.t_vtx_cen.x;
			v_cen.Y = g_m.t_vtx_cen.z;
		}
		else{
			v_min.X = g_m.vtx_min[idx-1].x;
			v_min.Y = g_m.vtx_min[idx-1].z;
			v_max.X = g_m.vtx_max[idx-1].x;
			v_max.Y = g_m.vtx_max[idx-1].z;
			v_cen.X = g_m.vtx_cen[idx-1].x;
			v_cen.Y = g_m.vtx_cen[idx-1].z;
		}
		break;
	}
	switch(g_m.direction)
	{
	case 1:	// 
		v_cen.X = - v_cen.X;
		break;
	case 3:	// E
		v_cen.X = - v_cen.X;
		break;
	case 4:	// 
		v_cen.Y = - v_cen.Y;
		break;
	}
	scale_x = rc.right  / (v_max.X - v_min.X);
	scale_y = rc.bottom / (v_max.Y - v_min.Y);
	scale_x < scale_y ? g_m.scale = scale_x : g_m.scale = scale_y;
	if(g_m.scale <= 0){
		g_m.scale = 1.0f;
	}
	g_b.wdh1 = (int)((v_max.X - v_min.X) * g_m.scale) + 12;
	g_b.hgt1 = (int)((v_max.Y - v_min.Y) * g_m.scale) + 12;
	
	// \ʒúA{̈ʒu (5, 5) Eɂ炷
	g_m.offset.X = (int)(((v_max.X - v_min.X) / 2 - v_cen.X) * g_m.scale) + 5;
	g_m.offset.Y = (int)(((v_max.Y - v_min.Y) / 2 + v_cen.Y) * g_m.scale) + 5;
}// Get_BmpRectPos

// ʕ
bool Divide_Faces(int idx_4, int idx_3)
{
	if(g_m.parts_ct + g_m.unit_ct == P_MAX - 1){
		MessageBox(g_hWnd,"p[cɒB܂B\n͕ł܂B",MYWNDTITLE,0);
	}
	if(g_m.parts_ct + g_m.unit_ct > P_MAX - 1){
		MessageBox(g_hWnd,"p[cɒB܂B\nł܂B",MYWNDTITLE,0);
		return 0;
	}
	
	DIV		d;
	int		i,j,k,idx;
	int		p_idx = -1;				// p[c̔ԍ
	bool	flag1,flag2;
	int		t_vtx_max,t_face_max;
	
	ZeroMemory(d.vtx_ct,  sizeof(d.vtx_ct));
	ZeroMemory(d.face_ct, sizeof(d.face_ct));
	
	t_face_max = g_m.t_face_ct * 4;	// ̑ʐi1ʂ4ʂɂȂ邽߁j
	t_vtx_max  = g_m.t_face_ct * 9;	// ̑_ȏ̐i1ʂ4_āAꂪ4ʂɂȂ9_ɂȂ邽߁j
	
	d.pv   = new VEC3  [t_vtx_max];
	d.pb   = new float [t_vtx_max];
	d.ptu  = new float [t_vtx_max];
	d.ptv  = new float [t_vtx_max];
	d.psel = new bool  [t_vtx_max];
	d.pf   = new int   [t_face_max][4];
	ZeroMemory(d.pv,   sizeof(VEC3)   * t_vtx_max);
	ZeroMemory(d.pb,   sizeof(float)  * t_vtx_max);
	ZeroMemory(d.ptu,  sizeof(float)  * t_vtx_max);
	ZeroMemory(d.ptv,  sizeof(float)  * t_vtx_max);
	ZeroMemory(d.psel, sizeof(bool)   * t_vtx_max);
	ZeroMemory(d.pf,   sizeof(int[4]) * t_face_max);
	
	flag2 = 0;
	d.t_vtx_ct = 0;
	d.t_face_ct = 0;
	for(k=0;k<g_m.parts_ct;k++){
		for(i=g_m.face_ct[k];i<g_m.face_ct[k+1];i++){
			flag1 = 0;
			for(j=0;j<4;j++){
				if(j != 3 || g_m.pf[i][3] != -1){
					idx = g_m.pf[i][j] + g_m.vtx_ct[k];
					if(!g_m.psel[idx]){
						flag1 = 1;
						break;
					}
				}
			}
			if(flag1){					// IĂȂʂ̏ꍇ
				Divide_Faces_Sub1(k, i, &d);
			}
			else if(!flag1){			// IĂʂ̏ꍇ
				flag2 = 1;
				
				if(g_m.pf[i][3] != -1){	// 1ʂ̒_4̏ꍇ
					Divide_Faces_Sub2(k, i, &d, idx_4);
				}
				else{					// 1ʂ̒_3̏ꍇ
					Divide_Faces_Sub2(k, i, &d, idx_3);
				}
				
			}
		}
	}
	
	g_m.t_vtx_ct  = d.t_vtx_ct;
	g_m.t_face_ct = d.t_face_ct;
	
	for(i=0;i<g_m.parts_ct+1;i++){
		g_m.vtx_ct[i]  = d.vtx_ct[i];
		g_m.face_ct[i] = d.face_ct[i];
	}
	
	FREE(g_m.pv);
	FREE(g_m.pn);
	FREE(g_m.pb);
	FREE(g_m.ptu);
	FREE(g_m.ptv);
	FREE(g_m.psel);
	FREE(g_m.pvis);
	FREE(g_m.pf);
	
	g_m.pv   = (LPVEC3) malloc(g_m.t_vtx_ct*sizeof(VEC3));
	g_m.pn   = (LPVEC3) malloc(g_m.t_vtx_ct*sizeof(VEC3));
	g_m.pb   = (float*) malloc(g_m.t_vtx_ct*sizeof(float));
	g_m.ptu  = (float*) malloc(g_m.t_vtx_ct*sizeof(float));
	g_m.ptv  = (float*) malloc(g_m.t_vtx_ct*sizeof(float));
	g_m.psel = (bool*)  malloc(g_m.t_vtx_ct*sizeof(bool));
	g_m.pvis = (bool*)  malloc(g_m.t_vtx_ct*sizeof(bool));
	g_m.pf   = (int(*)[4]) malloc(g_m.t_face_ct*sizeof(int[4]));
	ZeroMemory(g_m.pv,   sizeof(VEC3)   * g_m.t_vtx_ct);
	ZeroMemory(g_m.pn,   sizeof(VEC3)   * g_m.t_vtx_ct);
	ZeroMemory(g_m.pb,   sizeof(float)  * g_m.t_vtx_ct);
	ZeroMemory(g_m.ptu,  sizeof(float)  * g_m.t_vtx_ct);
	ZeroMemory(g_m.ptv,  sizeof(float)  * g_m.t_vtx_ct);
	ZeroMemory(g_m.psel, sizeof(bool)   * g_m.t_vtx_ct);
	ZeroMemory(g_m.pvis, sizeof(bool)   * g_m.t_vtx_ct);
	ZeroMemory(g_m.pf,   sizeof(int[4]) * g_m.t_face_ct);
	
	memcpy(g_m.pv,   d.pv,   sizeof(VEC3)   * g_m.t_vtx_ct);
	memcpy(g_m.pb,   d.pb,   sizeof(float)  * g_m.t_vtx_ct);
	memcpy(g_m.ptu,  d.ptu,  sizeof(float)  * g_m.t_vtx_ct);
	memcpy(g_m.ptv,  d.ptv,  sizeof(float)  * g_m.t_vtx_ct);
	memcpy(g_m.psel, d.psel, sizeof(bool)   * g_m.t_vtx_ct);
	memcpy(g_m.pf,   d.pf,   sizeof(int[4]) * g_m.t_face_ct);
	
	SAFE_DELETE_ARRAY(d.pv);
	SAFE_DELETE_ARRAY(d.pb);
	SAFE_DELETE_ARRAY(d.ptu);
	SAFE_DELETE_ARRAY(d.ptv);
	SAFE_DELETE_ARRAY(d.psel);
	SAFE_DELETE_ARRAY(d.pf);
	
	if(!flag2){
		MessageBox(g_hWnd,"IĂ钸_͂܂",MYWNDTITLE,0);
		return 0;
	}
	
	return 1;
}// Divide_Faces

// IĂȂʂ̏ꍇ
void Divide_Faces_Sub1(int k, int i, LPDIV d)
{
	int		j,l,idx,v_idx2;
	bool	flag3;
	
	for(j=0;j<4;j++){
		if(j != 3 || g_m.pf[i][3] != -1){
			idx = g_m.pf[i][j] + g_m.vtx_ct[k];
			flag3 = 0;
			for(l=d->vtx_ct[k];l<d->vtx_ct[k+1];l++){
				if(Vec3_Equal(d->pv[l], g_m.pv[idx])){
					flag3 = 1;
					v_idx2 = l;
					break;
				}
			}
			if(!flag3){
				d->pv[d->t_vtx_ct]  = g_m.pv[idx];
				d->pb[d->t_vtx_ct] =  g_m.pb[idx];
				d->ptu[d->t_vtx_ct] = g_m.ptu[idx];
				d->ptv[d->t_vtx_ct] = g_m.ptv[idx];
				v_idx2 = d->t_vtx_ct;
				d->t_vtx_ct ++;
				d->vtx_ct[k+1] = d->t_vtx_ct;
			} 
		}
		d->pf[d->t_face_ct][j] = v_idx2 - d->vtx_ct[k];
	}
	d->t_face_ct ++;
	d->face_ct[k+1] = d->t_face_ct;
}// Divide_Faces_Sub1

// Iꂽʂ2A܂4
void Divide_Faces_Sub2(int k, int i, LPDIV d, int idx)
{
	DIV2	d2[9];
	int		j,l;
	int		m,n;
	bool	flag4;
	int		v_num[13] = {9,6,6,6,7,7,7,5,5,5,4,4,4};
	
	// 4(2)\钸_WƃeNX`W߂
	Set_Divide_Vtx(k, i, d2, idx);
	
	// _̔ԍ߂
	for(j=0;j<v_num[idx];j++){
		flag4 = 0;
		for(l=d->vtx_ct[k];l<d->vtx_ct[k+1];l++){
			if(Vec3_Equal(d->pv[l], d2[j].v)){
				flag4 = 1;
				d2[j].v_idx = l;
				break;
			}
		}
		if(!flag4){
			d->pv[d->t_vtx_ct]   = d2[j].v;
			d->pb[d->t_vtx_ct]   = d2[j].b;
			d->ptu[d->t_vtx_ct]  = d2[j].tu;
			d->ptv[d->t_vtx_ct]  = d2[j].tv;
			d->psel[d->t_vtx_ct] = 1;
			d2[j].v_idx = d->t_vtx_ct;
			d->t_vtx_ct ++;
			d->vtx_ct[k+1] = d->t_vtx_ct;
		}
	}
	
	int m_max[13] = {4,2,2,4,4,4,4,2,2,2,2,2,2};
	int f[13][4][4] =	{
							{{0,4,8,7},{4,1,5,8},{7,8,6,3},{8,5,2,6}},
							{{0,1,4,5},{5,4,2,3}},
							{{0,4,5,3},{4,1,2,5}},
							{{0,3,5,-1},{5,4,2,-1},{5,3,4,-1},{3,1,4,-1}},
							{{2,6,4,-1},{2,5,6,-1},{4,6,3,1},{6,5,0,3}},
							{{0,6,5,-1},{0,3,6,-1},{5,6,4,2},{6,3,1,4}},
							{{1,6,3,-1},{1,4,6,-1},{3,6,5,0},{6,4,2,5}},
							{{2,4,3,-1},{3,4,0,1}},
							{{0,3,4,-1},{4,3,1,2}},
							{{1,4,3,-1},{3,4,2,0}},
							{{2,3,1,-1},{2,0,3,-1}},
							{{0,3,2,-1},{0,1,3,-1}},
							{{1,3,0,-1},{1,2,3,-1}}
						};
	
	for(m=0;m<m_max[idx];m++){
		for(n=0;n<4;n++){
			if(f[idx][m][n] == -1)
				d->pf[d->t_face_ct][n] = -1;
			else
				d->pf[d->t_face_ct][n] = d2[f[idx][m][n]].v_idx - d->vtx_ct[k];
		}
		d->t_face_ct ++;
		d->face_ct[k+1] = d->t_face_ct;
	}
}// Divide_Faces_Sub2

// ʕ̒_WƃeNX`W߂
void Set_Divide_Vtx(int k, int i, LPDIV2 d2, int idx)
{
	int	n;
	
	if(idx < 3){
		n = g_m.pf[i][0] + g_m.vtx_ct[k];
		d2[0].v  = g_m.pv[n];
		d2[0].b  = g_m.pb[n];
		d2[0].tu = g_m.ptu[n];
		d2[0].tv = g_m.ptv[n];
		n = g_m.pf[i][1] + g_m.vtx_ct[k];
		d2[1].v  = g_m.pv[n];
		d2[1].b =  g_m.pb[n];
		d2[1].tu = g_m.ptu[n];
		d2[1].tv = g_m.ptv[n];
		n = g_m.pf[i][2] + g_m.vtx_ct[k];
		d2[2].v  = g_m.pv[n];
		d2[2].b =  g_m.pb[n];
		d2[2].tu = g_m.ptu[n];
		d2[2].tv = g_m.ptv[n];
		n = g_m.pf[i][3] + g_m.vtx_ct[k];
		d2[3].v  = g_m.pv[n];
		d2[3].b =  g_m.pb[n];
		d2[3].tu = g_m.ptu[n];
		d2[3].tv = g_m.ptv[n];
		switch (idx)
		{
		case 0:	// _4,4
			d2[4].v  = Vec3_Center(d2[0].v, d2[1].v);
			d2[4].b  = (d2[0].b  + d2[1].b)  / 2;
			d2[4].tu = (d2[0].tu + d2[1].tu) / 2;
			d2[4].tv = (d2[0].tv + d2[1].tv) / 2;
			d2[5].v  = Vec3_Center(d2[1].v, d2[2].v);
			d2[5].b  = (d2[1].b  + d2[2].b)  / 2;
			d2[5].tu = (d2[1].tu + d2[2].tu) / 2;
			d2[5].tv = (d2[1].tv + d2[2].tv) / 2;
			d2[6].v  = Vec3_Center(d2[2].v, d2[3].v);
			d2[6].b  = (d2[2].b  + d2[3].b)  / 2;
			d2[6].tu = (d2[2].tu + d2[3].tu) / 2;
			d2[6].tv = (d2[2].tv + d2[3].tv) / 2;
			d2[7].v  = Vec3_Center(d2[3].v, d2[0].v);
			d2[7].b  = (d2[3].b  + d2[0].b)  / 2;
			d2[7].tu = (d2[3].tu + d2[0].tu) / 2;
			d2[7].tv = (d2[3].tv + d2[0].tv) / 2;
			d2[8].v  = Vec3_Center(d2[4].v, d2[6].v);
			d2[8].b  = (d2[4].b  + d2[6].b)  / 2;
			d2[8].tu = (d2[4].tu + d2[6].tu) / 2;
			d2[8].tv = (d2[4].tv + d2[6].tv) / 2;
			break;
		case 1:	// _4,2[1]
			d2[4].v  = Vec3_Center(d2[1].v, d2[2].v);
			d2[4].b  = (d2[1].b  + d2[2].b)  / 2;
			d2[4].tu = (d2[1].tu + d2[2].tu) / 2;
			d2[4].tv = (d2[1].tv + d2[2].tv) / 2;
			d2[5].v  = Vec3_Center(d2[3].v, d2[0].v);
			d2[5].b  = (d2[3].b  + d2[0].b)  / 2;
			d2[5].tu = (d2[3].tu + d2[0].tu) / 2;
			d2[5].tv = (d2[3].tv + d2[0].tv) / 2;
			break;
		case 2:	// _4,2[2]
			d2[4].v  = Vec3_Center(d2[0].v, d2[1].v);
			d2[4].b  = (d2[0].b  + d2[1].b)  / 2;
			d2[4].tu = (d2[0].tu + d2[1].tu) / 2;
			d2[4].tv = (d2[0].tv + d2[1].tv) / 2;
			d2[5].v  = Vec3_Center(d2[2].v, d2[3].v);
			d2[5].b  = (d2[2].b  + d2[3].b)  / 2;
			d2[5].tu = (d2[2].tu + d2[3].tu) / 2;
			d2[5].tv = (d2[2].tv + d2[3].tv) / 2;
			break;
		}
	}
	else{
		n = g_m.pf[i][0] + g_m.vtx_ct[k];
		d2[0].v  = g_m.pv[n];
		d2[0].b  = g_m.pb[n];
		d2[0].tu = g_m.ptu[n];
		d2[0].tv = g_m.ptv[n];
		n = g_m.pf[i][1] + g_m.vtx_ct[k];
		d2[1].v  = g_m.pv[n];
		d2[1].b  = g_m.pb[n];
		d2[1].tu = g_m.ptu[n];
		d2[1].tv = g_m.ptv[n];
		n = g_m.pf[i][2] + g_m.vtx_ct[k];
		d2[2].v  = g_m.pv[n];
		d2[2].b  = g_m.pb[n];
		d2[2].tu = g_m.ptu[n];
		d2[2].tv = g_m.ptv[n];
		switch (idx)
		{
		case 3:	// _3,4[1]
		case 4:	// _3,4[2-1]
		case 5:	// _3,4[2-2]
		case 6:	// _3,4[2-3]
			d2[3].v  = Vec3_Center(d2[0].v, d2[1].v);
			d2[3].b  = (d2[0].b  + d2[1].b ) / 2;
			d2[3].tu = (d2[0].tu + d2[1].tu) / 2;
			d2[3].tv = (d2[0].tv + d2[1].tv) / 2;
			d2[4].v  = Vec3_Center(d2[1].v, d2[2].v);
			d2[4].b  = (d2[1].b  + d2[2].b ) / 2;
			d2[4].tu = (d2[1].tu + d2[2].tu) / 2;
			d2[4].tv = (d2[1].tv + d2[2].tv) / 2;
			d2[5].v  = Vec3_Center(d2[2].v, d2[0].v);
			d2[5].b  = (d2[2].b  + d2[0].b ) / 2;
			d2[5].tu = (d2[2].tu + d2[0].tu) / 2;
			d2[5].tv = (d2[2].tv + d2[0].tv) / 2;
			if(idx == 4){
				d2[6].v  = Vec3_Center(d2[2].v, d2[3].v);
				d2[6].b  = (d2[2].b  + d2[3].b ) / 2;
				d2[6].tu = (d2[2].tu + d2[3].tu) / 2;
				d2[6].tv = (d2[2].tv + d2[3].tv) / 2;
			}
			else if(idx == 5){
				d2[6].v  = Vec3_Center(d2[0].v, d2[4].v);
				d2[6].b  = (d2[0].b  + d2[4].b ) / 2;
				d2[6].tu = (d2[0].tu + d2[4].tu) / 2;
				d2[6].tv = (d2[0].tv + d2[4].tv) / 2;
			}
			else if(idx == 6){
				d2[6].v  = Vec3_Center(d2[1].v, d2[5].v);
				d2[6].b  = (d2[1].b  + d2[5].b ) / 2;
				d2[6].tu = (d2[1].tu + d2[5].tu) / 2;
				d2[6].tv = (d2[1].tv + d2[5].tv) / 2;
			}
			break;
		case 7:	// _3,2[1-1]
			d2[3].v  = Vec3_Center(d2[1].v, d2[2].v);
			d2[3].b  = (d2[1].b  + d2[2].b ) / 2;
			d2[3].tu = (d2[1].tu + d2[2].tu) / 2;
			d2[3].tv = (d2[1].tv + d2[2].tv) / 2;
			d2[4].v  = Vec3_Center(d2[2].v, d2[0].v);
			d2[4].b  = (d2[2].b  + d2[0].b ) / 2;
			d2[4].tu = (d2[2].tu + d2[0].tu) / 2;
			d2[4].tv = (d2[2].tv + d2[0].tv) / 2;
			break;
		case 8:	// _3,2[1-2]
			d2[3].v  = Vec3_Center(d2[0].v, d2[1].v);
			d2[3].b  = (d2[0].b  + d2[1].b ) / 2;
			d2[3].tu = (d2[0].tu + d2[1].tu) / 2;
			d2[3].tv = (d2[0].tv + d2[1].tv) / 2;
			d2[4].v  = Vec3_Center(d2[2].v, d2[0].v);
			d2[4].b  = (d2[2].b  + d2[0].b ) / 2;
			d2[4].tu = (d2[2].tu + d2[0].tu) / 2;
			d2[4].tv = (d2[2].tv + d2[0].tv) / 2;
			break;
		case 9:	// _3,2[1-3]
			d2[3].v  = Vec3_Center(d2[0].v, d2[1].v);
			d2[3].b  = (d2[0].b  + d2[1].b ) / 2;
			d2[3].tu = (d2[0].tu + d2[1].tu) / 2;
			d2[3].tv = (d2[0].tv + d2[1].tv) / 2;
			d2[4].v  = Vec3_Center(d2[1].v, d2[2].v);
			d2[4].b  = (d2[1].b  + d2[2].b ) / 2;
			d2[4].tu = (d2[1].tu + d2[2].tu) / 2;
			d2[4].tv = (d2[1].tv + d2[2].tv) / 2;
			break;
		case 10:// _3,2[2-1]
			d2[3].v  = Vec3_Center(d2[0].v, d2[1].v);
			d2[3].b  = (d2[0].b  + d2[1].b ) / 2;
			d2[3].tu = (d2[0].tu + d2[1].tu) / 2;
			d2[3].tv = (d2[0].tv + d2[1].tv) / 2;
			break;
		case 11:// _3,2[2-2]
			d2[3].v  = Vec3_Center(d2[1].v, d2[2].v);
			d2[3].b  = (d2[1].b  + d2[2].b ) / 2;
			d2[3].tu = (d2[1].tu + d2[2].tu) / 2;
			d2[3].tv = (d2[1].tv + d2[2].tv) / 2;
			break;
		case 12:// _3,2[2-3]
			d2[3].v  = Vec3_Center(d2[2].v, d2[0].v);
			d2[3].b  = (d2[2].b  + d2[0].b ) / 2;
			d2[3].tu = (d2[2].tu + d2[0].tu) / 2;
			d2[3].tv = (d2[2].tv + d2[0].tv) / 2;
			break;
		}
	}
}// Set_Divide_Vtx

// @̍ČvZ(1xA4pغ݂3pغ݂ɕϊ)
void Set_Normals()
{
	int (*pf2)[3],*f_n;
	int i,j,ct;
	
	if(Ids < 0){
		return;
	}
	
	pf2 = new int [g_m.t_face_ct*2][3];
	f_n = new int [g_m.parts_ct+1];
	ZeroMemory(pf2, sizeof(int)*g_m.t_face_ct*2);
	ZeroMemory(f_n, sizeof(int)*(g_m.parts_ct+1));
	
	ct = 0;
	for(i=0;i<g_m.parts_ct;i++){
		for(j=g_m.face_ct[i];j<g_m.face_ct[i+1];j++){
			pf2[ct][0] = g_m.pf[j][0];
			pf2[ct][1] = g_m.pf[j][1];
			pf2[ct][2] = g_m.pf[j][2];
			ct ++;
			if(g_m.pf[j][3] != -1){
				pf2[ct][0] = g_m.pf[j][0];
				pf2[ct][1] = g_m.pf[j][2];
				pf2[ct][2] = g_m.pf[j][3];
				ct ++;
			}
		}
		f_n[i+1] = ct;
	}
	
	int (*pf_pre)[4],*p_face_ct_pre,t_face_ct_pre;
	t_face_ct_pre = g_m.t_face_ct;
	pf_pre = new int [g_m.t_face_ct][4];
	for(i=0;i<g_m.t_face_ct;i++){
		for(j=0;j<4;j++){
			pf_pre[i][j] = g_m.pf[i][j];
		}
	}
	p_face_ct_pre = new int [g_m.parts_ct+1];
	for(i=0;i<g_m.parts_ct+1;i++){
		p_face_ct_pre[i] = g_m.face_ct[i];
	}
	
	for(i=0;i<g_m.parts_ct+1;i++){
		g_m.face_ct[i] = f_n[i];
	}
	FREE(g_m.pf);
	g_m.t_face_ct = ct;
	g_m.pf = (int(*)[4]) malloc(g_m.t_face_ct*sizeof(int[4]));
	for(i=0;i<g_m.t_face_ct;i++){
		for(j=0;j<3;j++){
			g_m.pf[i][j] = pf2[i][j];
		}
		g_m.pf[i][3] = -1;
	}
	
	Set_Normals_Sub();	// @xNgZo
	
	g_m.t_face_ct = t_face_ct_pre;
	FREE(g_m.pf);
	g_m.pf = (int(*)[4]) malloc(g_m.t_face_ct*sizeof(int[4]));
	for(i=0;i<t_face_ct_pre;i++){
		for(j=0;j<4;j++){
			g_m.pf[i][j] = pf_pre[i][j];
		}
	}
	for(i=0;i<g_m.parts_ct+1;i++){
		g_m.face_ct[i] = p_face_ct_pre[i];
	}
	SAFE_DELETE_ARRAY(pf_pre);
	SAFE_DELETE_ARRAY(p_face_ct_pre);
	SAFE_DELETE_ARRAY(pf2);
	SAFE_DELETE_ARRAY(f_n);
}// Set_Normals

// @ݒ肷
void Set_Normals_Sub()
{
	int			i,j,k,l;
	float		bb = 0.0f,bb_x = 0.0f,bb_y = 0.0f,bb_z = 0.0f;
	float		angle;
	VEC3	*n_f,n_v,v2[3],v3[2];
	
	if(Ids < 0){
		return;
	}
	
	// ʂ̖@xNg
	float x[3],y[3],z[3];
	n_f = new VEC3 [g_m.t_face_ct];
		
	for(i=0;i<g_m.parts_ct;i++){
		for(j=g_m.face_ct[i];j<g_m.face_ct[i+1];j++){
			for(k=0;k<3;k++){
				x[k] = g_m.pv[g_m.pf[j][k] + g_m.vtx_ct[i]].x;
				y[k] = g_m.pv[g_m.pf[j][k] + g_m.vtx_ct[i]].y;
				z[k] = g_m.pv[g_m.pf[j][k] + g_m.vtx_ct[i]].z;
			}
			bb_x = (y[1]-y[0])*(z[2]-z[0]) - (z[1]-z[0])*(y[2]-y[0]);
			bb_y = (z[1]-z[0])*(x[2]-x[0]) - (x[1]-x[0])*(z[2]-z[0]);
			bb_z = (x[1]-x[0])*(y[2]-y[0]) - (y[1]-y[0])*(x[2]-x[0]);
			bb = (float)sqrt(bb_x * bb_x + bb_y * bb_y + bb_z * bb_z);
			if(bb == 0.0f){
				n_f[j].x = 0.0f;
				n_f[j].y = 0.0f;
				n_f[j].z = 0.0f;
			}
			else{
				n_f[j].x = bb_x / bb;
				n_f[j].y = bb_y / bb;
				n_f[j].z = bb_z / bb;
			}
		}
		
		// _̖@xNg
		for(j=g_m.vtx_ct[i];j<g_m.vtx_ct[i+1];j++){
			n_v.x = 0.0f;
			n_v.y = 0.0f;
			n_v.z = 0.0f;
			for(k=g_m.face_ct[i];k<g_m.face_ct[i+1];k++){
				for(l=0;l<3;l++){
					if((j - g_m.vtx_ct[i]) == g_m.pf[k][l]){
						v2[0] = g_m.pv[g_m.pf[k][0] + g_m.vtx_ct[i]];
						v2[1] = g_m.pv[g_m.pf[k][1] + g_m.vtx_ct[i]];
						v2[2] = g_m.pv[g_m.pf[k][2] + g_m.vtx_ct[i]];
						switch (l)
						{
						case 0:
							v3[0] = Vec3_Vector(v2[0], v2[1]);
							v3[1] = Vec3_Vector(v2[0], v2[2]);
							break;
						case 1:
							v3[0] = Vec3_Vector(v2[1], v2[0]);
							v3[1] = Vec3_Vector(v2[1], v2[2]);
							break;
						case 2:
							v3[0] = Vec3_Vector(v2[2], v2[0]);
							v3[1] = Vec3_Vector(v2[2], v2[1]);
							break;
						}
						angle = (float)acos(v3[0].x * v3[1].x + v3[0].y * v3[1].y + v3[0].z * v3[1].z);
						n_v.x += (n_f[k].x * angle);
						n_v.y += (n_f[k].y * angle);
						n_v.z += (n_f[k].z * angle);
						break;
					}
				}
			}
			bb = (float)sqrt(n_v.x * n_v.x + n_v.y * n_v.y + n_v.z * n_v.z);
			if(bb == 0.0f){
				n_v.x = 0.0f;
				n_v.y = 0.0f;
				n_v.z = 0.0f;
			}
			else{
				n_v.x /= bb;
				n_v.y /= bb;
				n_v.z /= bb;
			}
			g_m.pn[j] = n_v;
		}
	}
	SAFE_DELETE_ARRAY(n_f);
}// Set_Normals_Sub

// 2̍WxNg߂
VEC3 Vec3_Vector(VEC3 start, VEC3 end)
{
	VEC3	v;
	
	v.x = end.x - start.x;
	v.y = end.y - start.y;
	v.z = end.z - start.z;
	
	return v;
}// Vec3_Vector

// 2̍W̒S߂
VEC3 Vec3_Center(VEC3 a, VEC3 b)
{
	VEC3	v;
	
	v.x = (a.x + b.x) / 2;
	v.y = (a.y + b.y) / 2;
	v.z = (a.z + b.z) / 2;
	
	return v;
}// Vec3_Center

// 2̍Wꍇ true Ԃ
bool Vec3_Equal(VEC3 a, VEC3 b)
{
	if( a.x == b.x && 
		a.y == b.y && 
		a.z == b.z)
	{
		return 1;
	}
	return 0;
}// Vec3_Equal

// [ɖ߂]̃f[^
bool Set_Undo()
{
	int	i;
	
	if(!g_m.pv || !g_m.pn || !g_m.pb || !g_m.ptu || !g_m.ptv || !g_m.psel || !g_m.pvis || !g_m.pf){
		return false;
	}
	
	g_u.parts_ct  = g_m.parts_ct;
	g_u.t_vtx_ct  = g_m.t_vtx_ct;
	g_u.t_face_ct = g_m.t_face_ct;
	g_u.t_vtx_min = g_m.t_vtx_min;
	g_u.t_vtx_max = g_m.t_vtx_max;
	g_u.t_vtx_cen = g_m.t_vtx_cen;
	for(i=0;i<g_u.parts_ct+1;i++){
		g_u.vtx_ct[i]  = g_m.vtx_ct[i];
		g_u.face_ct[i] = g_m.face_ct[i];
	}
	for(i=0;i<g_u.parts_ct;i++){
		g_u.vtx_min[i]  = g_m.vtx_min[i];
		g_u.vtx_max[i]  = g_m.vtx_max[i];
		g_u.vtx_cen[i]  = g_m.vtx_cen[i];
	}
	for(i=0;i<P_MAX;i++){
		g_u.parent[i] = g_m.parent[i];
	}
	SAFE_DELETE_ARRAY(g_u.pv);
	SAFE_DELETE_ARRAY(g_u.pn);
	SAFE_DELETE_ARRAY(g_u.pb);
	SAFE_DELETE_ARRAY(g_u.ptu);
	SAFE_DELETE_ARRAY(g_u.ptv);
	SAFE_DELETE_ARRAY(g_u.psel);
	SAFE_DELETE_ARRAY(g_u.pvis);
	SAFE_DELETE_ARRAY(g_u.pf);
	g_u.pv   = new VEC3  [g_u.t_vtx_ct];
	g_u.pn   = new VEC3  [g_u.t_vtx_ct];
	g_u.pb   = new float [g_u.t_vtx_ct];
	g_u.ptu  = new float [g_u.t_vtx_ct];
	g_u.ptv  = new float [g_u.t_vtx_ct];
	g_u.psel = new bool  [g_u.t_vtx_ct];
	g_u.pvis = new bool  [g_u.t_vtx_ct];
	g_u.pf   = new int [g_u.t_face_ct][4];
	if(!g_u.pv || !g_u.pn || !g_u.pb || !g_u.ptu || !g_u.ptv || !g_u.psel || !g_u.pvis || !g_u.pf){
		return false;
	}
	ZeroMemory(g_u.pv,   sizeof(VEC3)  *g_u.t_vtx_ct);
	ZeroMemory(g_u.pn,   sizeof(VEC3)  *g_u.t_vtx_ct);
	ZeroMemory(g_u.pb,   sizeof(float) *g_u.t_vtx_ct);
	ZeroMemory(g_u.ptu,  sizeof(float) *g_u.t_vtx_ct);
	ZeroMemory(g_u.ptv,  sizeof(float) *g_u.t_vtx_ct);
	ZeroMemory(g_u.psel, sizeof(bool)  *g_u.t_vtx_ct);
	ZeroMemory(g_u.pvis, sizeof(bool)  *g_u.t_vtx_ct);
	ZeroMemory(g_u.pf,   sizeof(int[4])*g_u.t_face_ct);
	memcpy(g_u.pv,   g_m.pv,   sizeof(VEC3)  *g_u.t_vtx_ct);
	memcpy(g_u.pn,   g_m.pn,   sizeof(VEC3)  *g_u.t_vtx_ct);
	memcpy(g_u.pb,   g_m.pb,   sizeof(float) *g_u.t_vtx_ct);
	memcpy(g_u.ptu,  g_m.ptu,  sizeof(float) *g_u.t_vtx_ct);
	memcpy(g_u.ptv,  g_m.ptv,  sizeof(float) *g_u.t_vtx_ct);
	memcpy(g_u.psel, g_m.psel, sizeof(bool)  *g_u.t_vtx_ct);
	memcpy(g_u.pvis, g_m.pvis, sizeof(bool)  *g_u.t_vtx_ct);
	memcpy(g_u.pf,   g_m.pf,   sizeof(int[4])*g_u.t_face_ct);
	return true;
}// Set_Undo

// ɖ߂
bool Undo()
{
	int	i;
	
	if(!g_u.pv || !g_u.pn || !g_u.pb || !g_u.ptu || !g_u.ptv || !g_u.psel || !g_u.pvis || !g_u.pf){
		return false;
	}
	
	int n = g_m.parts_ct - g_u.parts_ct;
	
	g_m.parts_ct  = g_u.parts_ct;
	g_m.t_vtx_ct  = g_u.t_vtx_ct;
	g_m.t_face_ct = g_u.t_face_ct;
	g_m.t_vtx_min = g_u.t_vtx_min;
	g_m.t_vtx_max = g_u.t_vtx_max;
	g_m.t_vtx_cen = g_u.t_vtx_cen;
	for(i=0;i<g_m.parts_ct+1;i++){
		g_m.vtx_ct[i]  = g_u.vtx_ct[i];
		g_m.face_ct[i] = g_u.face_ct[i];
	}
	for(i=0;i<g_u.parts_ct;i++){
		g_m.vtx_min[i]  = g_u.vtx_min[i];
		g_m.vtx_max[i]  = g_u.vtx_max[i];
		g_m.vtx_cen[i]  = g_u.vtx_cen[i];
	}
	for(i=0;i<P_MAX;i++){
		g_m.parent[i] = g_u.parent[i];
	}
	FREE(g_m.pv);
	FREE(g_m.pn);
	FREE(g_m.pb);
	FREE(g_m.ptu);
	FREE(g_m.ptv);
	FREE(g_m.psel);
	FREE(g_m.pvis);
	FREE(g_m.pf);
	g_m.pv   = (LPVEC3) malloc(g_m.t_vtx_ct*sizeof(VEC3));
	g_m.pn   = (LPVEC3) malloc(g_m.t_vtx_ct*sizeof(VEC3));
	g_m.pb   = (float*) malloc(g_m.t_vtx_ct*sizeof(float));
	g_m.ptu  = (float*) malloc(g_m.t_vtx_ct*sizeof(float));
	g_m.ptv  = (float*) malloc(g_m.t_vtx_ct*sizeof(float));
	g_m.psel = (bool*)  malloc(g_m.t_vtx_ct*sizeof(bool));
	g_m.pvis = (bool*)  malloc(g_m.t_vtx_ct*sizeof(bool));
	g_m.pf   = (int(*)[4]) malloc(g_m.t_face_ct*sizeof(int[4]));
	if(!g_m.pv || !g_m.pn || !g_m.pb || !g_m.ptu || !g_m.ptv || !g_m.psel || !g_m.pvis || !g_m.pf){
		return false;
	}
	ZeroMemory(g_m.pv,   sizeof(VEC3)  *g_m.t_vtx_ct);
	ZeroMemory(g_m.pn,   sizeof(VEC3)  *g_m.t_vtx_ct);
	ZeroMemory(g_m.pb,   sizeof(float) *g_m.t_vtx_ct);
	ZeroMemory(g_m.ptu,  sizeof(float) *g_m.t_vtx_ct);
	ZeroMemory(g_m.ptv,  sizeof(float) *g_m.t_vtx_ct);
	ZeroMemory(g_m.psel, sizeof(bool)  *g_m.t_vtx_ct);
	ZeroMemory(g_m.pvis, sizeof(bool)  *g_m.t_vtx_ct);
	ZeroMemory(g_m.pf,   sizeof(int[4])*g_m.t_face_ct);
	memcpy(g_m.pv,   g_u.pv,   sizeof(VEC3)  *g_m.t_vtx_ct);
	memcpy(g_m.pn,   g_u.pn,   sizeof(VEC3)  *g_m.t_vtx_ct);
	memcpy(g_m.pb,   g_u.pb,   sizeof(float) *g_m.t_vtx_ct);
	memcpy(g_m.ptu,  g_u.ptu,  sizeof(float) *g_m.t_vtx_ct);
	memcpy(g_m.ptv,  g_u.ptv,  sizeof(float) *g_m.t_vtx_ct);
	memcpy(g_m.psel, g_u.psel, sizeof(bool)  *g_m.t_vtx_ct);
	memcpy(g_m.pvis, g_u.pvis, sizeof(bool)  *g_m.t_vtx_ct);
	memcpy(g_m.pf,   g_u.pf,   sizeof(int[4])*g_m.t_face_ct);
	
	SAFE_DELETE_ARRAY(g_u.pv);
	SAFE_DELETE_ARRAY(g_u.pn);
	SAFE_DELETE_ARRAY(g_u.pb);
	SAFE_DELETE_ARRAY(g_u.ptu);
	SAFE_DELETE_ARRAY(g_u.ptv);
	SAFE_DELETE_ARRAY(g_u.psel);
	SAFE_DELETE_ARRAY(g_u.pvis);
	SAFE_DELETE_ARRAY(g_u.pf);
	
	g_m.bFreeAll = 1;
	for(i=0;i<g_m.t_vtx_ct;i++){
		if(g_m.psel[i]){
			g_m.bFreeAll = 0;
			break;
		}
	}
	for(i=0;i<n;i++)
		SendMessage(g_hList, LB_DELETESTRING, g_m.parts_ct+1-i, 0);
	return true;
}// Undo

// gbvj[ACeARg[Ȃǂ̏Ԑݒ
void Set_TopMenuState()
{
	if(!g_b.pBmp){
		EnableMenuItem(g_hMenu, 1, MF_GRAYED | MF_BYPOSITION);
		EnableMenuItem(g_hMenu, 2, MF_GRAYED | MF_BYPOSITION);
		EnableWindow(g_hRebar_R, FALSE);
	}
	else{
		EnableMenuItem(g_hMenu, 1, MF_ENABLED | MF_BYPOSITION);
		EnableMenuItem(g_hMenu, 2, MF_ENABLED | MF_BYPOSITION);
		EnableWindow(g_hRebar_R, TRUE);
	}
	SendMessage(g_hChild, WM_SETREDRAW, FALSE, 0);
	DrawMenuBar(g_hWnd);
	SendMessage(g_hChild, WM_SETREDRAW, TRUE, 0);
	g_m.bFreeAll = 1;
	SendMessage(g_hTool_Main, TB_ENABLEBUTTON, IDM_SEP, MAKELONG(FALSE, 0));
	InvalidateRect(g_hChild, NULL, FALSE);
}// Set_TopMenuState

// Tuj[ACȅԐݒ
void Set_SubMenuState(HMENU hMenuSub, int index)
{
	switch(index)
	{
	case 0:
		if(!g_b.pBmp){
			EnableMenuItem(hMenuSub, IDM_SAVEAS, MF_GRAYED | MF_BYCOMMAND);
		}
		else{
			EnableMenuItem(hMenuSub, IDM_SAVEAS, MF_ENABLED | MF_BYCOMMAND);
		}
		break;
	case 1:
		if(!g_u.pv){
			EnableMenuItem(hMenuSub, IDM_UNDO, MF_GRAYED | MF_BYCOMMAND);
		}
		else{
			EnableMenuItem(hMenuSub, IDM_UNDO, MF_ENABLED | MF_BYCOMMAND);
		}
		if(g_m.bFreeAll){
			EnableMenuItem(hMenuSub, IDM_SEP, MF_GRAYED | MF_BYCOMMAND);
			EnableMenuItem(hMenuSub, IDM_DIVIDE, MF_GRAYED | MF_BYCOMMAND);
			EnableMenuItem(hMenuSub, 4, MF_GRAYED | MF_BYPOSITION);
			EnableMenuItem(hMenuSub, IDM_WEIGHT, MF_GRAYED | MF_BYCOMMAND);
		}
		else{
			EnableMenuItem(hMenuSub, IDM_SEP, MF_ENABLED | MF_BYCOMMAND);
			EnableMenuItem(hMenuSub, IDM_DIVIDE, MF_ENABLED | MF_BYCOMMAND);
			EnableMenuItem(hMenuSub, 4, MF_ENABLED | MF_BYPOSITION);
			EnableMenuItem(hMenuSub, IDM_WEIGHT, MF_ENABLED | MF_BYCOMMAND);
		}
		break;
	case 2:
		CheckMenuRadioItem(hMenuSub, 0, 5, g_m.direction, MF_BYPOSITION | MFS_CHECKED);
		break;
	}
}// Set_SubMenuState

// t@CJ
void Open_FileDlg(HWND hWnd)
{
	OPENFILENAME ofn;
	char fn[MAX_PATH];
	int r;
	
	fn[0] = '\0';
	
	ZeroMemory(&ofn, sizeof(ofn));
	ofn.lStructSize = sizeof(ofn);
	ofn.hwndOwner = hWnd;
	ofn.Flags = OFN_PATHMUSTEXIST | 
				OFN_FILEMUSTEXIST | 
				OFN_HIDEREADONLY;
	ofn.lpstrFile = fn;
	ofn.nMaxFile = sizeof(fn);
	ofn.lpstrFilter =	"ECT (*.ect)\0" "*.ect\0" 
						"ׂẴt@C (*.*)\0" "*.*\0";
	ofn.nFilterIndex = 1;
	r = GetOpenFileName(&ofn);
	if (r) {
		Load(fn);
	}
}// Open_FileDlg

// ۑt@C_CAO
bool Save_FileDlg()
{
	OPENFILENAME	ofn;
	char			fn[MAX_PATH],*p;
	bool			flag = 0;
	
	strcpy(fn, g_m.filename);
	p = strrchr(fn,'.');
	if(p)	strcpy(p,".ect");
	else	strcat(fn,".ect");
	
	ZeroMemory(&ofn, sizeof(OPENFILENAME));
	ofn.lStructSize  = sizeof(OPENFILENAME);
	ofn.hwndOwner    = g_hWnd;
	ofn.Flags        = OFN_HIDEREADONLY | OFN_OVERWRITEPROMPT | 
						OFN_ENABLEHOOK | OFN_EXPLORER; 
	ofn.lpstrFile    = fn;
	ofn.nMaxFile     = sizeof(fn);
	//tB^w肷ƂB
	ofn.lpstrFilter  =	"ECTt@C [eLXg`] (*.ect)\0" "*.ect\0" 
						"ECTt@C [oCi`] (*.ect)\0" "*.ect\0";
	ofn.nFilterIndex = g_flag_bin + 1;
	
	if (GetSaveFileName(&ofn)) {
		
		p = strrchr(fn,'.');
		if(!p)	strcat(fn,".ect");
		
		switch (ofn.nFilterIndex)
		{
		case 1:
			flag = Save_File_E(fn);
			g_flag_bin = 0;
			break;
		case 2:
			flag = Save_File_E_Bin(fn);
			g_flag_bin = 1;
			break;
		}
		if(flag){
			strcpy(g_m.filename, fn);
			return true;
		}
	}
	return false;
}// Save_FileDlg

// t@C̓ǂݍ
bool Load(char *filename)
{
	g_flag_bin = 0;
	
	if(GetFileAttributes(filename) != -1){
		char *p;
		p = strrchr(filename,'.');
		if(p && !stricmp(p+1,"ect")){
			if(!( Load_File_E(filename) )){
				if(!( Load_File_E_Bin(filename) )){
					MessageBox(g_hWnd,"t@C̓ǂݍ݂Ɏs܂",MYWNDTITLE,0);
					return 0;
				}
				else{
					g_flag_bin = 1;
				}
			}
			strcpy(g_m.filename, filename);
		}
		else{
			MessageBox(g_hWnd,"ECTt@Cł͂܂",MYWNDTITLE,0);
			return 0;
		}
	}
	else{
		MessageBox(g_hWnd,"t@C܂",MYWNDTITLE,0);
		return 0;
	}
	if(g_m.parts_ct + g_m.unit_ct >= P_MAX){
		MessageBox(g_hWnd,"p[cɒB܂B\nł܂B",MYWNDTITLE,0);
		return 0;
	}
	SendMessage(g_hList, LB_RESETCONTENT, 0, 0);
	SendMessage(g_hList, LB_ADDSTRING, 0, (LPARAM) "- S -");
	for(int i=0;i<g_m.parts_ct;i++)
		SendMessage(g_hList, LB_ADDSTRING, 0, (LPARAM) g_m.name[i]);
	SendMessage(g_hList, LB_SETCURSEL, 0, 0);
	SendMessage(g_hTool_Main, TB_CHECKBUTTON, IDM_FRONT, MAKELONG(TRUE, 0));
	Load_Bmp();
	Zoom_100();
	Set_Center();
	g_m.direction = 0;
	g_m.bSel = 0;
	Set_TopMenuState();
	SetForegroundWindow(g_hWnd);
	return 1;
}// Load

// ECTt@C̓ǂݍ݁ieLXg`j
bool Load_File_E(char *filename)
{
	FILE 	*file1;
	
	char 	ss[256];
	int		flag = 0;
	int 	p_ct = 0,ct1 = 0,ct2 = 0,ct3 = 0,ct4 = 0,ct5 = 0;
	
	Term();		// Oϐ̏
	
	for(int i=0;i<P_MAX;i++){
		for(int j=0;j<2;j++){
			g_m.tex_scale[i][j] = 1.0f;
		}
	}
	
	if((file1=fopen(filename,"r")) == NULL){
		return 0;		
	}
	
	g_m.vtx_ct[0] = 0;
	g_m.face_ct[0] = 0;
	
	while(!feof(file1)){
		
		fgets(ss,256,file1);
		if(ss[strlen(ss)-1] == '\n'){
			ss[strlen(ss)-1] = '\0';
		}
		
		// o[W
		if(!strcmp(ss,"<version>")){
			flag = 1;
		}
		else if(!strcmp(ss,"</version>")){
			flag = 0;
		}
		else if(flag == 1){
			sscanf(ss,"%s",g_m.strVer);
		}
		
		// p[c̐
		else if(!strcmp(ss,"<parts_count>")){
			flag = 2;
		}
		else if(!strcmp(ss,"</parts_count>")){
			flag = 0;
			if(g_m.parts_ct >= P_MAX){
				fclose(file1);
				char es[256];
				sprintf(es,"p[c%d𒴂܂",P_MAX);
				MessageBox(g_hWnd,es,MYWNDTITLE,MB_OK);
				return 0;
			}
		}
		else if(flag == 2){
			sscanf(ss,"%d", &g_m.parts_ct);
			if(g_m.parts_ct >= P_MAX){
				fclose(file1);
				return 0;
			}
		}
		
		// [V̐
		else if(!strcmp(ss,"<motion_count>")){
			flag = 3;
		}
		else if(!strcmp(ss,"</motion_count>")){
			flag = 0;
		}
		else if(flag == 3){
			sscanf(ss,"%d",&g_m.mt_ct);
			if(g_m.mt_ct >= M_MAX){
				fclose(file1);
				return 0;
			}
		}
		
		// jbg̐
		else if(!strcmp(ss,"<unit_count>")){
			flag = 4;
		}
		else if(!strcmp(ss,"</unit_count>")){
			flag = 0;
		}
		else if(flag == 4){
			sscanf(ss,"%d",&g_m.unit_ct);
			if(g_m.unit_ct >= P_MAX){
				fclose(file1);
				return 0;
			}
		}
		
		// IuWFNgŜ̒_W̐
		else if(!strcmp(ss,"<total_vertex_count>")){
			flag = 5;
		}
		else if(!strcmp(ss,"</total_vertex_count>")){
			flag = 0;
		}
		else if(flag == 5){
			sscanf(ss,"%d", &g_m.t_vtx_ct);
			g_m.pv   = (LPVEC3) malloc(g_m.t_vtx_ct*sizeof(VEC3));
			g_m.pn   = (LPVEC3) malloc(g_m.t_vtx_ct*sizeof(VEC3));
			g_m.pb   = (float*) malloc(g_m.t_vtx_ct*sizeof(float));
			g_m.ptu  = (float*) malloc(g_m.t_vtx_ct*sizeof(float));
			g_m.ptv  = (float*) malloc(g_m.t_vtx_ct*sizeof(float));
			g_m.psel = (bool*)  malloc(g_m.t_vtx_ct*sizeof(bool));
			g_m.pvis = (bool*)  malloc(g_m.t_vtx_ct*sizeof(bool));
			ZeroMemory(g_m.pv,   sizeof(VEC3)  * g_m.t_vtx_ct);
			ZeroMemory(g_m.pn,   sizeof(VEC3)  * g_m.t_vtx_ct);
			ZeroMemory(g_m.pb,   sizeof(float) * g_m.t_vtx_ct);
			ZeroMemory(g_m.ptu,  sizeof(float) * g_m.t_vtx_ct);
			ZeroMemory(g_m.ptv,  sizeof(float) * g_m.t_vtx_ct);
			ZeroMemory(g_m.psel, sizeof(bool)  * g_m.t_vtx_ct);
			ZeroMemory(g_m.pvis, sizeof(bool)  * g_m.t_vtx_ct);
		}
		
		// IuWFNgŜ̖ʂ̐
		else if(!strcmp(ss,"<total_face_count>")){
			flag = 6;
		}
		else if(!strcmp(ss,"</total_face_count>")){
			flag = 0;
		}
		else if(flag == 6){
			sscanf(ss,"%d", &g_m.t_face_ct);
			g_m.pf = (int(*)[4]) malloc(g_m.t_face_ct*sizeof(int[4]));
			ZeroMemory(g_m.pf, sizeof(int[4]) * g_m.t_face_ct);
		}
		
		// _W̍ŏliŚj
		else if(!strcmp(ss,"<total_corner_min>")){
			flag = 7;
		}
		else if(!strcmp(ss,"</total_corner_min>")){
			flag = 0;
		}
		else if(flag == 7){
			sscanf(ss,"%f %f %f",&g_m.t_vtx_min.x,&g_m.t_vtx_min.y,&g_m.t_vtx_min.z);
		}
		
		// _W̍őliŚj
		else if(!strcmp(ss,"<total_corner_max>")){
			flag = 8;
		}
		else if(!strcmp(ss,"</total_corner_max>")){
			flag = 0;
		}
		else if(flag == 8){
			sscanf(ss,"%f %f %f",&g_m.t_vtx_max.x,&g_m.t_vtx_max.y,&g_m.t_vtx_max.z);
		}
		
		// SWiŚj
		else if(!strcmp(ss,"<total_center>")){
			flag = 9;
		}
		else if(!strcmp(ss,"</total_center>")){
			flag = 0;
		}
		else if(flag == 9){
			sscanf(ss,"%f %f %f",&g_m.t_vtx_cen.x,&g_m.t_vtx_cen.y,&g_m.t_vtx_cen.z);
		}
		
		// eNX`}bvS̃tO
		else if(!strcmp(ss,"<texture_all>")){
			flag = 10;
		}
		else if(!strcmp(ss,"</texture_all>")){
			flag = 0;
		}
		else if(flag == 10){
			sscanf(ss,"%d",&g_m.flag_tex_all);
		}
		
		// p[c
		else if(!strcmp(ss,"<parts_name>")){
			flag = 11;
		}
		else if(!strcmp(ss,"</parts_name>")){
			flag = 0;
		}
		else if(flag == 11){
			sscanf(ss,"%s", g_m.name[p_ct]);
		}
		
		// _W̍ŏlip[cj
		else if(!strcmp(ss,"<corner_min>")){
			flag = 12;
		}
		else if(!strcmp(ss,"</corner_min>")){
			flag = 0;
		}
		else if(flag == 12){
			sscanf(ss,"%f %f %f",&g_m.vtx_min[p_ct].x,&g_m.vtx_min[p_ct].y,&g_m.vtx_min[p_ct].z);
		}
		
		// _W̍őlip[cj
		else if(!strcmp(ss,"<corner_max>")){
			flag = 13;
		}
		else if(!strcmp(ss,"</corner_max>")){
			flag = 0;
		}
		else if(flag == 13){
			sscanf(ss,"%f %f %f",&g_m.vtx_max[p_ct].x,&g_m.vtx_max[p_ct].y,&g_m.vtx_max[p_ct].z);
		}
		
		// SWip[cj
		else if(!strcmp(ss,"<center>")){
			flag = 14;
			ct1 = 0;
		}
		else if(!strcmp(ss,"</center>")){
			flag = 0;
		}
		else if(flag == 14){
			sscanf(ss,"%f %f %f",&g_m.vtx_cen[p_ct].x,&g_m.vtx_cen[p_ct].y,&g_m.vtx_cen[p_ct].z);
		}
		
		// p[cƂ̃fBt[YF
		else if(!strcmp(ss,"<diffuse>")){
			flag = 15;
		}
		else if(!strcmp(ss,"</diffuse>")){
			flag = 0;
		}
		else if(flag == 15){
			sscanf(ss,"%f %f %f %f",&g_m.mtrl[p_ct][3],&g_m.mtrl[p_ct][0],&g_m.mtrl[p_ct][1],&g_m.mtrl[p_ct][2]);
			g_m.mtrl[p_ct][7] = g_m.mtrl[p_ct][3];
			g_m.mtrl[p_ct][4] = g_m.mtrl[p_ct][0];
			g_m.mtrl[p_ct][5] = g_m.mtrl[p_ct][1];
			g_m.mtrl[p_ct][6] = g_m.mtrl[p_ct][2];
		}
		
		// p[cƂ̃XyLF
		else if(!strcmp(ss,"<specular>")){
			flag = 16;
		}
		else if(!strcmp(ss,"</specular>")){
			flag = 0;
		}
		else if(flag == 16){
			sscanf(ss,"%f %f %f %f",&g_m.mtrl[p_ct][11],&g_m.mtrl[p_ct][8],&g_m.mtrl[p_ct][9],&g_m.mtrl[p_ct][10]);
		}
		
		// p[cƂ̃G~bVF
		else if(!strcmp(ss,"<emission>")){
			flag = 17;
		}
		else if(!strcmp(ss,"</emission>")){
			flag = 0;
		}
		else if(flag == 17){
			sscanf(ss,"%f %f %f %f",&g_m.mtrl[p_ct][15],&g_m.mtrl[p_ct][12],&g_m.mtrl[p_ct][13],&g_m.mtrl[p_ct][14]);
		}
		
		// XyLFx
		else if(!strcmp(ss,"<specular_power>")){
			flag = 18;
		}
		else if(!strcmp(ss,"</specular_power>")){
			flag = 0;
		}
		else if(flag == 18){
			sscanf(ss,"%f",&g_m.mtrl[p_ct][16]);
		}
		
		// eNX`̃t@C
		else if(!strcmp(ss,"<texture_file>")){
			flag = 19;
		}
		else if(!strcmp(ss,"</texture_file>")){
			flag = 0;
		}
		else if(flag == 19){
			sscanf(ss,"%s",g_m.tex_name[p_ct]);
		}
		
		// eNX`}bsÕtOi0:ʃ}bv 1:}bv 2:bsOj
		else if(!strcmp(ss,"<texture_map_flag>")){
			flag = 20;
		}
		else if(!strcmp(ss,"</texture_map_flag>")){
			flag = 0;
		}
		else if(flag == 20){
			sscanf(ss,"%d",&g_m.flag_map[p_ct]);
		}
		
		// eNX`W̕Ɣ䗦ƕsړ
		else if(!strcmp(ss,"<texture_map_param>")){
			flag = 21;
		}
		else if(!strcmp(ss,"</texture_map_param>")){
			flag = 0;
		}
		else if(flag == 21){
			sscanf(ss,"%d %f %f %f %f",&g_m.tex_dir[p_ct],&g_m.tex_scale[p_ct][0],&g_m.tex_scale[p_ct][1],&g_m.tex_trans[p_ct][0],&g_m.tex_trans[p_ct][1]);
		}
		
		// ǂݍ񂾃p[c̐
		else if(!strcmp(ss,"</polygon_mesh>")){
			p_ct ++;
		}
		
		// _ip[cj
		else if(!strcmp(ss,"<vertex_count>")){
			flag = 22;
		}
		else if(!strcmp(ss,"</vertex_count>")){
			flag = 0;
		}
		else if(flag == 22){
			sscanf(ss,"%d", &g_m.vtx_ct[p_ct+1]);
			g_m.vtx_ct[p_ct+1] += g_m.vtx_ct[p_ct];
		}
		
		// p[cƂ̒_W
		else if(!strcmp(ss,"<vertices>")){
			flag = 23;
		}
		else if(!strcmp(ss,"</vertices>")){
			flag = 0;
		}
		else if(flag == 23){
			int num = sscanf(ss,"%f %f %f %f %f %f %f %f %f", &g_m.pv[ct2].x, &g_m.pv[ct2].y, &g_m.pv[ct2].z, &g_m.pn[ct2].x, &g_m.pn[ct2].y, &g_m.pn[ct2].z, &g_m.ptu[ct2], &g_m.ptv[ct2], &g_m.pb[ct2]);
			if(num == 9){
				g_flag_blend = 1;
			}ct2 ++;
		}
		
		// ʐip[cj
		else if(!strcmp(ss,"<face_count>")){
			flag = 24;
		}
		else if(!strcmp(ss,"</face_count>")){
			flag = 0;
		}
		else if(flag == 24){
			sscanf(ss,"%d", &g_m.face_ct[p_ct+1]);
			g_m.face_ct[p_ct+1] += g_m.face_ct[p_ct];
		}
		
		// p[cƂ̖ʂ\钸_W̔ԍ
		else if(!strcmp(ss,"<faces>")){
			flag = 25;
		}
		else if(!strcmp(ss,"</faces>")){
			flag = 0;
		}
		else if(flag == 25){
			sscanf(ss,"%d %d %d %d", &g_m.pf[ct3][0], &g_m.pf[ct3][1], &g_m.pf[ct3][2], &g_m.pf[ct3][3]);
			ct3 ++;
		}
		
		// jbg{
		else if(!strcmp(ss,"<basis>")){
			flag = 26;
			ct1 = 0;
		}
		else if(!strcmp(ss,"</basis>")){
			flag = 0;
		}
		else if(flag == 26){
			sscanf(ss,"%f %f %f %d %d %d %s %d %d",&g_m.ax_v[ct1].x,&g_m.ax_v[ct1].y,&g_m.ax_v[ct1].z,&g_m.ax_roll[ct1][0],&g_m.ax_roll[ct1][1],&g_m.ax_roll[ct1][2],g_m.unit_name[ct1],&g_m.ax_b_dir[ct1],&g_m.ax_b_prop[ct1]);
			if(ss[0] == '1')
				sscanf(ss,"%d %f %f %f %d %d %d %s %d %d",&g_m.ax_flag[ct1],&g_m.ax_v[ct1].x,&g_m.ax_v[ct1].y,&g_m.ax_v[ct1].z,&g_m.ax_roll[ct1][0],&g_m.ax_roll[ct1][1],&g_m.ax_roll[ct1][2],g_m.unit_name[ct1],&g_m.ax_b_dir[ct1],&g_m.ax_b_prop[ct1]);
			else
				sscanf(ss,"%d %f %f %f %s %d %d",&g_m.ax_flag[ct1],&g_m.ax_v[ct1].x,&g_m.ax_v[ct1].y,&g_m.ax_v[ct1].z,g_m.unit_name[ct1],&g_m.ax_b_dir[ct1],&g_m.ax_b_prop[ct1]);
			ct1 ++;
		}
		
		// e̔ԍ
		else if(!strcmp(ss,"<parent>")){
			flag = 27;
			ct1 = 0;
		}
		else if(!strcmp(ss,"</parent>")){
			flag = 0;
		}
		else if(flag == 27){
			sscanf(ss,"%d",&g_m.parent[ct1]);
			ct1 ++;
		}
		
		// jbg̉]px
		else if(!strcmp(ss,"<angle>")){
			flag = 28;
			ct1 = 0;
		}
		else if(!strcmp(ss,"</angle>")){
			flag = 0;
			ct4 ++;
		}
		else if(flag == 28){
			if(g_m.ax_flag[ct1] == 1)
				sscanf(ss,"%d",&g_m.mt_roll[ct4][ct1][0]);
			else
				sscanf(ss,"%d %d %d",&g_m.mt_roll[ct4][ct1][0],&g_m.mt_roll[ct4][ct1][1],&g_m.mt_roll[ct4][ct1][2]);
			ct1 ++;
		}
		
		// jbg̕sړ
		else if(!strcmp(ss,"<translation>")){
			flag = 29;
			ct1 = 0;
			g_flag_translation = 1;
		}
		else if(!strcmp(ss,"</translation>")){
			flag = 0;
			ct5 ++;
		}
		else if(flag == 29){
			if(ct5 < g_m.mt_ct){
				sscanf(ss,"%f %f %f",&g_m.mt_pos[ct5][ct1].x,&g_m.mt_pos[ct5][ct1].y,&g_m.mt_pos[ct5][ct1].z);
				ct1 ++;
			}
		}
		
		// Aj̐
		else if(!strcmp(ss,"<anim_count>")){
			flag = 30;
		}
		else if(!strcmp(ss,"</anim_count>")){
			flag = 0;
		}
		else if(flag == 30){
			sscanf(ss,"%d",&g_m.anim_ct);
			if(g_m.anim_ct >= M_MAX)
				g_m.anim_ct = M_MAX - 1;
			g_flag_anim = TRUE;
		}
		
		// Aj f[^
		else if(!strcmp(ss,"<anim_data>")){
			flag = 31;
			ct1 = 0;
		}
		else if(!strcmp(ss,"</anim_data>")){
			flag = 0;
		}
		else if(flag == 31){
			sscanf(ss,"%d %d %d %s",&g_m.as[ct1].iStart,&g_m.as[ct1].iEnd,&g_m.as[ct1].flag_loop,g_m.as[ct1].name);
			ct1 ++;
		}
	}
	
	if(fclose(file1))
		return 0;
	
	if(!g_m.parts_ct || !g_m.t_vtx_ct || !g_m.t_face_ct)
		return 0;
	
	return 1;
}// Load_File_E

// ECTt@C̓ǂݍ݁ioCi`j
bool Load_File_E_Bin(char *filename)
{
	FILE	*file1;
	int		i,j,k,len,tg,tag_num;
	UINT	len_tag,size;
	char	tag[TAG_LEN],type[4];
	
	Term();		// Oϐ̏
	
	if((file1=fopen(filename,"rb")) == NULL){
		return 0;		
	}
	
	fread(type,sizeof(char),4,file1);
	if(strcmp(type, "ECT")){
		fclose(file1);
		return 0;
	}
	fread(&tag_num,sizeof(int),1,file1);
	for(tg=0;tg<tag_num;tg++){
		fread(&len_tag,sizeof(int),1,file1);
		if(len_tag > sizeof(tag))	len_tag = sizeof(tag);
		fread(tag,sizeof(char),len_tag,file1);
		fread(&size,sizeof(int),1,file1);
		bool flag = false;
		for(k=0;k<sizeof(g_tag)/sizeof(g_tag[0]);k++){
			if(!strcmp(tag, g_tag[k])){
				flag = true;
switch(k)
{
case 0:
	{
		UINT len;
		fread(&len,sizeof(int),1,file1);
		if(len > sizeof(g_m.strVer))
			len = sizeof(g_m.strVer);
		fread(&g_m.strVer,sizeof(char),len,file1);
	}
	break;
case 1:
	fread(&g_m.parts_ct,sizeof(int),1,file1);
	if(g_m.parts_ct >= P_MAX){
		fclose(file1);
		char es[256];
		sprintf(es,"p[c%d𒴂܂",P_MAX);
		MessageBox(g_hWnd,es,MYWNDTITLE,MB_OK);
		return 0;
	}
	break;
case 2:
	fread(&g_m.mt_ct,sizeof(int),1,file1);
	if(g_m.mt_ct >= M_MAX)
		g_m.mt_ct = M_MAX - 1;
	break;
case 3:
	fread(&g_m.unit_ct,sizeof(int),1,file1);
	if(g_m.unit_ct >= P_MAX)
		g_m.unit_ct = P_MAX - 1;
	break;
case 4:
	fread(&g_m.t_vtx_ct,sizeof(int),1,file1);
	g_m.pv   = (LPVEC3) malloc(g_m.t_vtx_ct*sizeof(VEC3));
	g_m.pn   = (LPVEC3) malloc(g_m.t_vtx_ct*sizeof(VEC3));
	g_m.pb   = (float*) malloc(g_m.t_vtx_ct*sizeof(float));
	g_m.ptu  = (float*) malloc(g_m.t_vtx_ct*sizeof(float));
	g_m.ptv  = (float*) malloc(g_m.t_vtx_ct*sizeof(float));
	g_m.psel = (bool*)  malloc(g_m.t_vtx_ct*sizeof(bool));
	g_m.pvis = (bool*)  malloc(g_m.t_vtx_ct*sizeof(bool));
	ZeroMemory(g_m.pv,   sizeof(VEC3)  * g_m.t_vtx_ct);
	ZeroMemory(g_m.pn,   sizeof(VEC3)  * g_m.t_vtx_ct);
	ZeroMemory(g_m.pb,   sizeof(float) * g_m.t_vtx_ct);
	ZeroMemory(g_m.ptu,  sizeof(float) * g_m.t_vtx_ct);
	ZeroMemory(g_m.ptv,  sizeof(float) * g_m.t_vtx_ct);
	ZeroMemory(g_m.psel, sizeof(bool)  * g_m.t_vtx_ct);
	ZeroMemory(g_m.pvis, sizeof(bool)  * g_m.t_vtx_ct);
	break;
case 5:
	fread(&g_m.t_face_ct,sizeof(int),1,file1);
	g_m.pf = (int(*)[4]) malloc(g_m.t_face_ct*sizeof(int[4]));
	ZeroMemory(g_m.pf, sizeof(int[4]) * g_m.t_face_ct);
	break;
case 6:
	fread(&g_m.t_vtx_min,sizeof(VEC3),1,file1);
	fread(&g_m.t_vtx_max,sizeof(VEC3),1,file1);
	break;
case 7:
	fread(&g_m.t_vtx_cen,sizeof(VEC3),1,file1);
	break;
case 8:
	fread(&g_m.flag_tex_all,sizeof(int),1,file1);
	break;
case 9:
	for(i=0;i<g_m.parts_ct;i++){
		fread(&len,sizeof(int),1,file1);
		fread(g_m.name[i],sizeof(char),len,file1);
	}
	break;
case 10:
	for(i=0;i<g_m.parts_ct;i++){
		fread(&g_m.vtx_min[i],sizeof(VEC3),1,file1);
		fread(&g_m.vtx_max[i],sizeof(VEC3),1,file1);
	}
	break;
case 11:
	fread(g_m.vtx_cen,sizeof(VEC3),g_m.parts_ct,file1);
	break;
case 12:
	fread(g_m.mtrl,sizeof(float),17*g_m.parts_ct,file1);
	break;
case 13:
	for(i=0;i<g_m.parts_ct;i++){
		fread(&len,sizeof(int),1,file1);
		fread(g_m.tex_name[i],sizeof(char),len,file1);
	}
	break;
case 14:
	fread(g_m.flag_map,sizeof(int),g_m.parts_ct,file1);
	break;
case 15:
	for(i=0;i<g_m.parts_ct;i++){
		fread(&g_m.tex_dir,sizeof(int),1,file1);
		fread(&g_m.tex_scale,sizeof(float),2,file1);
		fread(&g_m.tex_trans,sizeof(float),2,file1);
	}
	break;
case 16:
	g_m.vtx_ct[0] = 0;
	for(i=0;i<g_m.parts_ct;i++){
		fread(&g_m.vtx_ct[i+1],sizeof(int),1,file1);
		g_m.vtx_ct[i+1] += g_m.vtx_ct[i];
	}
	break;
case 17:
	g_m.face_ct[0] = 0;
	for(i=0;i<g_m.parts_ct;i++){
		fread(&g_m.face_ct[i+1],sizeof(int),1,file1);
		g_m.face_ct[i+1] += g_m.face_ct[i];
	}
	break;
case 18:
	fread(g_m.pv,sizeof(VEC3),g_m.t_vtx_ct,file1);
	break;
case 19:
	fread(g_m.pn,sizeof(VEC3),g_m.t_vtx_ct,file1);
	break;
case 20:
	for(i=0;i<g_m.t_vtx_ct;i++){
		fread(&g_m.ptu[i],sizeof(float),1,file1);
		fread(&g_m.ptv[i],sizeof(float),1,file1);
	}
	break;
case 21:
	fread(g_m.pf,sizeof(int[4]),g_m.t_face_ct,file1);
	break;
case 22:
	for(i=0;i<g_m.unit_ct;i++){
		fread(&g_m.ax_flag[i],sizeof(int),1,file1);
		fread(&g_m.ax_v[i].x,sizeof(float),1,file1);
		fread(&g_m.ax_v[i].y,sizeof(float),1,file1);
		fread(&g_m.ax_v[i].z,sizeof(float),1,file1);
		if(g_m.ax_flag[i] == 1){
			fread(&g_m.ax_roll[i][0],sizeof(int),1,file1);
			fread(&g_m.ax_roll[i][1],sizeof(int),1,file1);
			fread(&g_m.ax_roll[i][2],sizeof(int),1,file1);
		}
		fread(&len,sizeof(int),1,file1);
		fread(g_m.unit_name[i],sizeof(char),len,file1);
	}
	break;
case 23:
	fread(g_m.parent,sizeof(int),g_m.parts_ct+g_m.unit_ct,file1);
	break;
case 24:
	for(i=0;i<g_m.mt_ct;i++){
		for(j=0;j<g_m.unit_ct;j++){
			fread(&g_m.mt_roll[i][j][0],sizeof(int),1,file1);
			if(g_m.ax_flag[j] == 2){
				fread(&g_m.mt_roll[i][j][1],sizeof(int),1,file1);
				fread(&g_m.mt_roll[i][j][2],sizeof(int),1,file1);
			}
		}
	}
	break;
case 25:
	for(i=0;i<g_m.mt_ct;i++){
		for(j=0;j<g_m.unit_ct;j++){
			fread(&g_m.mt_pos[i][j],sizeof(VEC3),1,file1);
		}
	}
	g_flag_translation = 1;
	break;
case 26:
	{
		int num = fread(g_m.pb,sizeof(float),g_m.t_vtx_ct,file1);
		if(num == g_m.t_vtx_ct){
			g_flag_blend = 1;
		}
		for(i=0;i<g_m.unit_ct;i++){
			fread(&g_m.ax_b_dir[i],sizeof(int),1,file1);
			fread(&g_m.ax_b_prop[i],sizeof(int),1,file1);
		}
	}
	break;
case 27:
	fread(&g_m.anim_ct,sizeof(int),1,file1);
	if(g_m.anim_ct >= M_MAX)
		g_m.anim_ct = M_MAX - 1;
	g_flag_anim = TRUE;
	break;
case 28:
	for(i=0;i<g_m.anim_ct;i++){
		fread(&g_m.as[i].iStart,sizeof(int),1,file1);
		fread(&g_m.as[i].iEnd,sizeof(int),1,file1);
		fread(&g_m.as[i].flag_loop,sizeof(bool),1,file1);
		fread(&len,sizeof(int),1,file1);
		fread(g_m.as[i].name,sizeof(char),len,file1);
	}
	break;
}
				break;
			}
		}
		if(!flag)
			fseek(file1, size, SEEK_CUR);			// ǂݔ΂
	}
	
	if(fclose(file1))
		return 0;
	
	if(!g_m.parts_ct || !g_m.t_vtx_ct || !g_m.t_face_ct)
		return 0;
	
	return 1;
}// Load_File_E_Bin

// ETC t@CɕۑieLXg`j
bool Save_File_E(char *filename)
{
	FILE *file2;
	int  i,j;
	
	SetCursor(LoadCursor(NULL,IDC_WAIT));
	
	if((file2=fopen(filename,"w")) == NULL){
		MessageBox(g_hWnd,"t@C쐬ł܂",MYWNDTITLE,MB_OK | MB_ICONSTOP);
		return 0;
	}
	
	if(fputs("<version>",file2) == EOF){
		fclose(file2);
		MessageBox(g_hWnd,"t@Cۑł܂",MYWNDTITLE,MB_OK | MB_ICONSTOP);
		return 0;
	}
	if(!strcmp(g_m.strVer,"")){
		strcpy(g_m.strVer,"1.61");
	}
	fprintf(file2,"\n%s",g_m.strVer);
	fputs("\n</version>",file2);
	fputs("\n<parts_count>",file2);
	fprintf(file2,"\n%d",g_m.parts_ct);
	fputs("\n</parts_count>",file2);
	fputs("\n<motion_count>",file2);
	fprintf(file2,"\n%d",g_m.mt_ct);
	fputs("\n</motion_count>",file2);
	fputs("\n<unit_count>",file2);
	fprintf(file2,"\n%d",g_m.unit_ct);
	fputs("\n</unit_count>",file2);
	fputs("\n<total_vertex_count>",file2);
	fprintf(file2,"\n%d",g_m.t_vtx_ct);
	fputs("\n</total_vertex_count>",file2);
	fputs("\n<total_face_count>",file2);
	fprintf(file2,"\n%d",g_m.t_face_ct);
	fputs("\n</total_face_count>",file2);
	fputs("\n<total_corner_min>",file2);
	fprintf(file2,"\n%f %f %f",g_m.t_vtx_min.x,g_m.t_vtx_min.y,g_m.t_vtx_min.z);
	fputs("\n</total_corner_min>",file2);
	fputs("\n<total_corner_max>",file2);
	fprintf(file2,"\n%f %f %f",g_m.t_vtx_max.x,g_m.t_vtx_max.y,g_m.t_vtx_max.z);
	fputs("\n</total_corner_max>",file2);
	fputs("\n<total_center>",file2);
	fprintf(file2,"\n%f %f %f",g_m.t_vtx_cen.x,g_m.t_vtx_cen.y,g_m.t_vtx_cen.z);
	fputs("\n</total_center>",file2);
	fputs("\n<texture_all>",file2);
	fprintf(file2,"\n%d",g_m.flag_tex_all);
	fputs("\n</texture_all>",file2);
	// bV
	for(i=0;i<g_m.parts_ct;i++){
		fputs("\n<polygon_mesh>",file2);
		fputs("\n<parts_name>",file2);
		fprintf(file2,"\n%s",g_m.name[i]);
		fputs("\n</parts_name>",file2);
		fputs("\n<corner_min>",file2);
		fprintf(file2,"\n%f %f %f",g_m.vtx_min[i].x,g_m.vtx_min[i].y,g_m.vtx_min[i].z);
		fputs("\n</corner_min>",file2);
		fputs("\n<corner_max>",file2);
		fprintf(file2,"\n%f %f %f",g_m.vtx_max[i].x,g_m.vtx_max[i].y,g_m.vtx_max[i].z);
		fputs("\n</corner_max>",file2);
		fputs("\n<center>",file2);
		fprintf(file2,"\n%f %f %f",g_m.vtx_cen[i].x,g_m.vtx_cen[i].y,g_m.vtx_cen[i].z);
		fputs("\n</center>",file2);
		fputs("\n<diffuse>",file2);
		fprintf(file2,"\n%f %f %f %f",g_m.mtrl[i][3],g_m.mtrl[i][0],g_m.mtrl[i][1],g_m.mtrl[i][2]);
		fputs("\n</diffuse>",file2);
		fputs("\n<specular>",file2);
		fprintf(file2,"\n%f %f %f %f",g_m.mtrl[i][11],g_m.mtrl[i][8],g_m.mtrl[i][9],g_m.mtrl[i][10]);
		fputs("\n</specular>",file2);
		fputs("\n<emission>",file2);
		fprintf(file2,"\n%f %f %f %f",g_m.mtrl[i][15],g_m.mtrl[i][12],g_m.mtrl[i][13],g_m.mtrl[i][14]);
		fputs("\n</emission>",file2);
		fputs("\n<specular_power>",file2);
		fprintf(file2,"\n%f",g_m.mtrl[i][16]);
		fputs("\n</specular_power>",file2);
		fputs("\n<texture_file>",file2);
		fprintf(file2,"\n%s",g_m.tex_name[i]);
		fputs("\n</texture_file>",file2);
		fputs("\n<texture_map_flag>",file2);
		fprintf(file2,"\n%d",g_m.flag_map[i]);
		fputs("\n</texture_map_flag>",file2);
		fputs("\n<texture_map_param>",file2);
		fprintf(file2,"\n%d %f %f %f %f",g_m.tex_dir[i],g_m.tex_scale[i][0],g_m.tex_scale[i][1],g_m.tex_trans[i][0],g_m.tex_trans[i][1]);
		fputs("\n</texture_map_param>",file2);
		fputs("\n<vertex_count>",file2);
		fprintf(file2,"\n%d",g_m.vtx_ct[i+1] - g_m.vtx_ct[i]);
		fputs("\n</vertex_count>",file2);
		fputs("\n<vertices>",file2);
		for(j=g_m.vtx_ct[i];j<g_m.vtx_ct[i+1];j++){
			if(g_flag_blend){
				fprintf(file2,"\n%f %f %f %f %f %f %f %f %f",
				g_m.pv[j].x,g_m.pv[j].y,g_m.pv[j].z,g_m.pn[j].x,g_m.pn[j].y,g_m.pn[j].z,
				g_m.ptu[j],g_m.ptv[j],g_m.pb[j]);
			}
			else{
				fprintf(file2,"\n%f %f %f %f %f %f %f %f",
				g_m.pv[j].x,g_m.pv[j].y,g_m.pv[j].z,g_m.pn[j].x,g_m.pn[j].y,g_m.pn[j].z,
				g_m.ptu[j],g_m.ptv[j]);
			}
		}
		
		fputs("\n</vertices>",file2);
		fputs("\n<face_count>",file2);
		fprintf(file2,"\n%d",g_m.face_ct[i+1] - g_m.face_ct[i]);
		fputs("\n</face_count>",file2);
		fputs("\n<faces>",file2);
		for(j=g_m.face_ct[i];j<g_m.face_ct[i+1];j++){
			fprintf(file2,"\n%d %d %d %d",g_m.pf[j][0],g_m.pf[j][1],g_m.pf[j][2],g_m.pf[j][3]);
		}
		fputs("\n</faces>",file2);
		fputs("\n</polygon_mesh>",file2);
	}
	// jbgƃAj̏
	if(g_m.unit_ct > 0){
		// jbg
		fputs("\n<unit>",file2);
		fputs("\n<basis>",file2);
		for(i=0;i<g_m.unit_ct;i++){
			if(g_flag_blend){
				if(g_m.ax_flag[i] == 1){
					fprintf(file2,"\n%d %f %f %f %d %d %d %s %d %d",
						g_m.ax_flag[i],g_m.ax_v[i].x,g_m.ax_v[i].y,g_m.ax_v[i].z,
						g_m.ax_roll[i][0],g_m.ax_roll[i][1],g_m.ax_roll[i][2],
						g_m.unit_name[i],g_m.ax_b_dir[i],g_m.ax_b_prop[i]);
				}
				else{
					fprintf(file2,"\n%d %f %f %f %s %d %d",
						g_m.ax_flag[i],g_m.ax_v[i].x,g_m.ax_v[i].y,g_m.ax_v[i].z,
						g_m.unit_name[i],g_m.ax_b_dir[i],g_m.ax_b_prop[i]);
				}
			}
			else{
				if(g_m.ax_flag[i] == 1){
					fprintf(file2,"\n%d %f %f %f %d %d %d %s",
						g_m.ax_flag[i],g_m.ax_v[i].x,g_m.ax_v[i].y,g_m.ax_v[i].z,
						g_m.ax_roll[i][0],g_m.ax_roll[i][1],g_m.ax_roll[i][2],
						g_m.unit_name[i]);
				}
				else{
					fprintf(file2,"\n%d %f %f %f %s",
						g_m.ax_flag[i],g_m.ax_v[i].x,g_m.ax_v[i].y,g_m.ax_v[i].z,
						g_m.unit_name[i]);
				}
			}
		}
		fputs("\n</basis>",file2);
		fputs("\n<parent>",file2);
		for(i=0;i<g_m.parts_ct+g_m.unit_ct;i++){
			fprintf(file2,"\n%d",g_m.parent[i]);
		}
		fputs("\n</parent>",file2);
		for(i=0;i<g_m.mt_ct;i++){
			fputs("\n<angle>",file2);
			for(j=0;j<g_m.unit_ct;j++){
				if(g_m.ax_flag[j] == 1)
					fprintf(file2,"\n%d",g_m.mt_roll[i][j][0]);
				else
					fprintf(file2,"\n%d %d %d",g_m.mt_roll[i][j][0],g_m.mt_roll[i][j][1],g_m.mt_roll[i][j][2]);
			}
			fputs("\n</angle>",file2);
		}
		if(g_flag_translation){
			for(i=0;i<g_m.mt_ct;i++){
				fputs("\n<translation>",file2);
				for(j=0;j<g_m.unit_ct;j++){
					fprintf(file2,"\n%f %f %f",g_m.mt_pos[i][j].x,g_m.mt_pos[i][j].y,g_m.mt_pos[i][j].z);
				}
				fputs("\n</translation>",file2);
			}
		}
		fputs("\n</unit>",file2);
		// Aj
		if(g_flag_anim){
			fputs("\n<anim_count>",file2);
			fprintf(file2,"\n%d",g_m.anim_ct);
			fputs("\n</anim_count>",file2);
			fputs("\n<anim_data>",file2);
			for(i=0;i<g_m.anim_ct;i++){
				fprintf(file2,"\n%d %d %d %s",g_m.as[i].iStart,g_m.as[i].iEnd,g_m.as[i].flag_loop,g_m.as[i].name);
			}
			fputs("\n</anim_data>",file2);
		}
	}
	
	if(fclose(file2))
		return 0;
	
	SetCursor(NULL);
	
	return 1;
}// Save_File_E

// ECT t@CioCi`jɃ^O
void Fwrite_Tag(FILE *file2, int idx, int size)
{
	int len = (strlen(g_tag[idx])+1);
	
	fwrite(&len,sizeof(int),1,file2);
	fwrite(g_tag[idx],sizeof(char),len,file2);
	fwrite(&size,sizeof(int),1,file2);
}// Fwrite_Tag

// ECT t@CɕۑioCi`j
bool Save_File_E_Bin(char *filename)
{
	FILE	*file2;
	int		i,j,len_ct,n;
	int		name_len[P_MAX];
	
	SetCursor(LoadCursor(NULL,IDC_WAIT));
	
	if((file2=fopen(filename,"wb")) == NULL){
		MessageBox(g_hWnd,"t@C쐬ł܂",MYWNDTITLE,MB_OK | MB_ICONSTOP);
		return 0;
	}
	
	fwrite("ECT",sizeof(char),4,file2);
	int tag_num = sizeof(g_tag)/sizeof(g_tag[0]);
	fwrite(&tag_num,sizeof(int),1,file2);
	if(!strcmp(g_m.strVer,"")){
		strcpy(g_m.strVer,"1.61");
	}
	len_ct = strlen(g_m.strVer)+1;
	Fwrite_Tag(file2, 0, sizeof(int)+len_ct);
	fwrite(&len_ct,sizeof(int),1,file2);
	fwrite(g_m.strVer,sizeof(char),len_ct,file2);
	Fwrite_Tag(file2, 1, sizeof(int));
	fwrite(&g_m.parts_ct,sizeof(int),1,file2);
	Fwrite_Tag(file2, 2, sizeof(int));
	fwrite(&g_m.mt_ct,sizeof(int),1,file2);
	Fwrite_Tag(file2, 3, sizeof(int));
	fwrite(&g_m.unit_ct,sizeof(int),1,file2);
	Fwrite_Tag(file2, 4, sizeof(int));
	fwrite(&g_m.t_vtx_ct,sizeof(int),1,file2);
	Fwrite_Tag(file2, 5, sizeof(int));
	fwrite(&g_m.t_face_ct,sizeof(int),1,file2);
	Fwrite_Tag(file2, 6, sizeof(VEC3)*2);
	fwrite(&g_m.t_vtx_min,sizeof(VEC3),1,file2);
	fwrite(&g_m.t_vtx_max,sizeof(VEC3),1,file2);
	Fwrite_Tag(file2, 7, sizeof(VEC3));
	fwrite(&g_m.t_vtx_cen,sizeof(VEC3),1,file2);
	Fwrite_Tag(file2, 8, sizeof(int));
	fwrite(&g_m.flag_tex_all,sizeof(int),1,file2);
	len_ct = 0;
	for(i=0;i<g_m.parts_ct;i++){
		name_len[i] = (strlen(g_m.name[i])+1);
		len_ct += name_len[i];
	}
	Fwrite_Tag(file2, 9, sizeof(int)*g_m.parts_ct+sizeof(char)*len_ct);
	for(i=0;i<g_m.parts_ct;i++){
		fwrite(&name_len[i],sizeof(int),1,file2);
		fwrite(g_m.name[i],sizeof(char),name_len[i],file2);
	}
	Fwrite_Tag(file2, 10, sizeof(VEC3)*2*g_m.parts_ct);
	for(i=0;i<g_m.parts_ct;i++){
		fwrite(&g_m.vtx_min[i],sizeof(VEC3),1,file2);
		fwrite(&g_m.vtx_max[i],sizeof(VEC3),1,file2);
	}
	Fwrite_Tag(file2, 11, sizeof(VEC3)*g_m.parts_ct);
	fwrite(g_m.vtx_cen,sizeof(VEC3),g_m.parts_ct,file2);
	Fwrite_Tag(file2, 12, sizeof(float)*17*g_m.parts_ct);
	fwrite(g_m.mtrl,sizeof(float),17*g_m.parts_ct,file2);
	len_ct = 0;
	for(i=0;i<g_m.parts_ct;i++){
		name_len[i] = (strlen(g_m.tex_name[i])+1);
		len_ct += name_len[i];
	}
	Fwrite_Tag(file2, 13, sizeof(int)*g_m.parts_ct+sizeof(char)*len_ct);
	for(i=0;i<g_m.parts_ct;i++){
		fwrite(&name_len[i],sizeof(int),1,file2);
		fwrite(g_m.tex_name[i],sizeof(char),name_len[i],file2);
	}
	Fwrite_Tag(file2, 14, sizeof(int)*g_m.parts_ct);
	fwrite(g_m.flag_map,sizeof(int),g_m.parts_ct,file2);
	Fwrite_Tag(file2, 15, (sizeof(int)+sizeof(float)*4)*g_m.parts_ct);
	for(i=0;i<g_m.parts_ct;i++){
		fwrite(&g_m.tex_dir[i],sizeof(int),1,file2);
		fwrite(&g_m.tex_scale[i],sizeof(float),2,file2);
		fwrite(&g_m.tex_trans[i],sizeof(float),2,file2);
	}
	Fwrite_Tag(file2, 16, sizeof(int)*g_m.parts_ct);
	for(i=0;i<g_m.parts_ct;i++){
		n = g_m.vtx_ct[i+1] - g_m.vtx_ct[i];
		fwrite(&n,sizeof(int),1,file2);
	}
	Fwrite_Tag(file2, 17, sizeof(int)*g_m.parts_ct);
	for(i=0;i<g_m.parts_ct;i++){
		n = g_m.face_ct[i+1] - g_m.face_ct[i];
		fwrite(&n,sizeof(int),1,file2);
	}
	Fwrite_Tag(file2, 18, sizeof(VEC3)*g_m.t_vtx_ct);
	fwrite(g_m.pv,sizeof(VEC3),g_m.t_vtx_ct,file2);
	Fwrite_Tag(file2, 19, sizeof(VEC3)*g_m.t_vtx_ct);
	fwrite(g_m.pn,sizeof(VEC3),g_m.t_vtx_ct,file2);
	Fwrite_Tag(file2, 20, sizeof(float)*2*g_m.t_vtx_ct);
	for(i=0;i<g_m.t_vtx_ct;i++){
		fwrite(&g_m.ptu[i],sizeof(float),1,file2);
		fwrite(&g_m.ptv[i],sizeof(float),1,file2);
	}
	Fwrite_Tag(file2, 21, sizeof(int[4])*g_m.t_face_ct);
	fwrite(g_m.pf,sizeof(int[4]),g_m.t_face_ct,file2);
	// jbg
	if(g_m.unit_ct > 0){
		len_ct = 0;
		for(i=0;i<g_m.unit_ct;i++){
			name_len[i] = (strlen(g_m.unit_name[i])+1);
			len_ct += name_len[i];
		}
		int basis_size = (sizeof(float)*3+sizeof(int)*3+sizeof(int))*g_m.unit_ct+sizeof(char)*len_ct;
		Fwrite_Tag(file2, 22, basis_size);
		for(i=0;i<g_m.unit_ct;i++){
			fwrite(&g_m.ax_flag[i],sizeof(int),1,file2);
			fwrite(&g_m.ax_v[i].x,sizeof(float),1,file2);
			fwrite(&g_m.ax_v[i].y,sizeof(float),1,file2);
			fwrite(&g_m.ax_v[i].z,sizeof(float),1,file2);
			if(g_m.ax_flag[i] == 1){
				fwrite(&g_m.ax_roll[i][0],sizeof(int),1,file2);
				fwrite(&g_m.ax_roll[i][1],sizeof(int),1,file2);
				fwrite(&g_m.ax_roll[i][2],sizeof(int),1,file2);
			}
			fwrite(&name_len[i],sizeof(int),1,file2);
			fwrite(g_m.unit_name[i],sizeof(char),name_len[i],file2);
		}
		int item_ct = g_m.parts_ct + g_m.unit_ct;
		Fwrite_Tag(file2, 23, sizeof(int)*item_ct);
		fwrite(g_m.parent,sizeof(int),item_ct,file2);
		Fwrite_Tag(file2, 24, sizeof(int)*g_m.mt_ct*g_m.unit_ct);
		for(i=0;i<g_m.mt_ct;i++){
			for(j=0;j<g_m.unit_ct;j++){
				fwrite(&g_m.mt_roll[i][j][0],sizeof(int),1,file2);
				if(g_m.ax_flag[j] == 2){
					fwrite(&g_m.mt_roll[i][j][1],sizeof(int),1,file2);
					fwrite(&g_m.mt_roll[i][j][2],sizeof(int),1,file2);
				}
			}
		}
		if(g_flag_translation){
			Fwrite_Tag(file2, 25, sizeof(VEC3)*g_m.mt_ct*g_m.unit_ct);
			for(i=0;i<g_m.mt_ct;i++){
				for(j=0;j<g_m.unit_ct;j++){
					fwrite(&g_m.mt_pos[i][j],sizeof(VEC3),1,file2);
				}
			}
		}
		if(g_flag_blend){
			Fwrite_Tag(file2, 26, sizeof(float)*g_m.t_vtx_ct+sizeof(int)*2*g_m.unit_ct);
			fwrite(g_m.pb,sizeof(float),g_m.t_vtx_ct,file2);
			for(i=0;i<g_m.unit_ct;i++){
				fwrite(&g_m.ax_b_dir[i],sizeof(int),1,file2);
				fwrite(&g_m.ax_b_prop[i],sizeof(int),1,file2);
			}
		}
		if(g_flag_anim){
			Fwrite_Tag(file2, 27, sizeof(int));
			fwrite(&g_m.anim_ct,sizeof(int),1,file2);
			len_ct = 0;
			for(i=0;i<g_m.anim_ct;i++){
				name_len[i] = (strlen(g_m.as[i].name)+1);
				len_ct += name_len[i];
			}
			int anim_data_size = (sizeof(int)*3+sizeof(bool))*g_m.anim_ct+sizeof(char)*len_ct;
			Fwrite_Tag(file2, 28, anim_data_size);
			for(i=0;i<g_m.anim_ct;i++){
				fwrite(&g_m.as[i].iStart,sizeof(int),1,file2);
				fwrite(&g_m.as[i].iEnd,sizeof(int),1,file2);
				fwrite(&g_m.as[i].flag_loop,sizeof(bool),1,file2);
				fwrite(&name_len[i],sizeof(int),1,file2);
				fwrite(g_m.as[i].name,sizeof(char),name_len[i],file2);
			}
		}
	}
	
	if(fclose(file2))
		return 0;
	SetCursor(NULL);
	return 1;
}// Save_File_E_Bin

// I
void Term()
{
	//̈
	SAFE_DELETE_OBJ(g_b.pBmp);
	FREE(g_m.pv);
	FREE(g_m.pn);
	FREE(g_m.pb);
	FREE(g_m.ptu);
	FREE(g_m.ptv);
	FREE(g_m.psel);
	FREE(g_m.pvis);
	FREE(g_m.pf);
	SAFE_DELETE_ARRAY(g_u.pv);
	SAFE_DELETE_ARRAY(g_u.pn);
	SAFE_DELETE_ARRAY(g_u.pb);
	SAFE_DELETE_ARRAY(g_u.ptu);
	SAFE_DELETE_ARRAY(g_u.ptv);
	SAFE_DELETE_ARRAY(g_u.psel);
	SAFE_DELETE_ARRAY(g_u.pvis);
	SAFE_DELETE_ARRAY(g_u.pf);
	// Oϐ̏
	Ids = 0;
	g_flag_blend = 0;
	g_flag_bin = 0;
	g_flag_translation = 0;
	ZeroMemory(&g_m, sizeof(g_m));
}// Term
