// Child		1524 `
// StatusBar	1540 `
// Rebar		1556 `
// Tool			1572 `
// Static		1652 `
// Slider		1684 `
// Spin			1700 `

// Rg[̈ʒuƃTCY
typedef struct{
	int x,y,wdh,hgt;
}CSIZE,*LPCSIZE;

HWND	Set_Child(HWND hWnd, char *cls, DWORD exStyle);
HWND	Set_StatusBar(HWND hWnd);
HWND	Set_Rebar(HWND hWnd, bool flag_Vert);
HWND	Set_Tool(HWND hWnd, bool flag_Vert);
HWND	Set_Static(HWND hParent, CSIZE sz, char *text);
HWND	Set_Edit(HWND hParent, CSIZE sz, UINT ID_EDIT, bool flag_Vert);
HWND	Set_Slider(HWND hParent, CSIZE sz);
HWND	Set_Spin(HWND hParent, CSIZE sz, bool flag_Vert);
HWND	Set_List(HWND hParent, CSIZE sz, UINT ID_LIST);
bool	Menu_State_Check(HMENU hMenu, UINT ID);
CSIZE	SetCsize(int x, int y, int wdh, int hgt);
SIZE	Get_StrSize(HWND hWnd, HGDIOBJ sobj, char *str);

// qEBhE̍쐬
HWND Set_Child(HWND hWnd, char *cls, DWORD exStyle)
{
	static int k = 0;
	
	HWND hChild = CreateWindowEx(
				exStyle,
				cls,
				NULL,
				WS_CHILD | WS_VISIBLE | WS_CLIPCHILDREN,
				0, 0, 0, 0,
				hWnd,
				(HMENU) 1524 + k++,
				GetModuleHandle(NULL),
				NULL);
	return (hChild);
}// Set_Child

// Xe[^Xo[̍쐬
HWND Set_StatusBar(HWND hWnd)
{
	static int k = 0;
	HWND hStatus = CreateWindowEx(0,
					STATUSCLASSNAME,
					NULL,
					SBARS_SIZEGRIP | WS_CHILD | WS_VISIBLE,
					0, 0, 0, 0,
					hWnd,
					(HMENU) 1540 + k++,
					GetModuleHandle(NULL),
					NULL);
	return (hStatus);
}// Set_StatusBar

// o[Rg[̍쐬
// flag_VertFc^  1A^  0
HWND Set_Rebar(HWND hWnd, bool flag_Vert)
{
	UINT style;
	if(flag_Vert){
		style = CCS_VERT;
	}
	else{
		style = RBS_FIXEDORDER | RBS_AUTOSIZE;
	}
	REBARINFO				rbi;
	static int k = 0;
	HWND hRebar = CreateWindowEx(WS_EX_TOOLWINDOW,
								REBARCLASSNAME,
								NULL,
								WS_BORDER |
								WS_CHILD |
								WS_VISIBLE |
								WS_CLIPCHILDREN |
								WS_CLIPSIBLINGS |
								RBS_BANDBORDERS | 
								CCS_NODIVIDER | 
								CCS_NOPARENTALIGN |
								style,
								0, 0, 0, 0,
								hWnd,
								(HMENU) 1556 + k++,
								GetModuleHandle(NULL),
								NULL);
	
	rbi.cbSize	= sizeof(REBARINFO);
	rbi.fMask	= 0;
	rbi.himl	= (HIMAGELIST)NULL;
	SendMessage(hRebar, RB_SETBARINFO, 0, (LPARAM)&rbi);
	return (hRebar);
}// Set_Rebar

// c[o[̍쐬
// flag_VertFc^  1A^  0
HWND Set_Tool(HWND hWnd, bool flag_Vert)
{
	UINT style;
	if(flag_Vert){
		style = CCS_VERT;
	}
	else{
		style = 0;
	}
	static int k = 0;
	HWND hTool = CreateWindowEx(0,
								TOOLBARCLASSNAME,
								NULL,
								WS_CHILD | 
								WS_CLIPCHILDREN | 
								TBSTYLE_TOOLTIPS | 
								TBSTYLE_FLAT | 
								TBSTYLE_WRAPABLE | 
								CCS_NORESIZE | 
								CCS_NODIVIDER | 
								style,
								0,0,0,0,
								hWnd,
								(HMENU) 1572 + k++,
								GetModuleHandle(NULL),
								NULL);
	SendMessage(hTool, TB_BUTTONSTRUCTSIZE, sizeof(TBBUTTON), 0);
	return (hTool);
}// Set_Tool

// X^eBbNRg[̍쐬
HWND Set_Static(HWND hParent, CSIZE sz, char *text, bool flag_Vert)
{
	CSIZE sz_st;
	if(flag_Vert){
		sz_st = SetCsize(sz.y, sz.x, sz.hgt, 0);
	}
	else{
		sz_st = SetCsize(sz.x, sz.y, 0, sz.hgt);
	}

	static int k = 0;
	HWND hStatic = CreateWindowEx(0,
								"STATIC",
								text,
								SS_LEFT | WS_CHILD | WS_VISIBLE,
								0, 0, 0, 0,
								hParent,
								(HMENU) 1652 + k++,
								GetModuleHandle(NULL),
								NULL);
	// tHg̐ݒ
	HGDIOBJ 	sobj = NULL;
	sobj = GetStockObject(DEFAULT_GUI_FONT);
	if(sobj == NULL)
		sobj = GetStockObject(ANSI_VAR_FONT);
	if(sobj)
		SendMessage(hStatic, WM_SETFONT, (WPARAM) sobj, MAKELPARAM(TRUE, 0));
	// \ʒu̐ݒ
	if(sobj){
		SIZE size;
		size = Get_StrSize(hStatic, sobj, text);
		if(flag_Vert){
			sz_st.x = (sz_st.wdh - size.cx) / 2;
			if(sz_st.x < 0)	sz_st.x = 0;
		}
		else{
			sz_st.y = (sz_st.hgt - size.cy) / 2;
			if(sz_st.y < 0)	sz_st.y = 0;
		}
		MoveWindow(hStatic, sz_st.x, sz_st.y, size.cx, size.cy, FALSE);
	}
	
	return (hStatic);
}// Set_Static

// GfBbg̍쐬
// flag_VertFc^  1A^  0
HWND Set_Edit(HWND hParent, CSIZE sz, UINT ID_EDIT, bool flag_Vert)
{
	UINT style,styleEx;
	CSIZE sz_e;
	if(flag_Vert){
		style = ES_READONLY;
		styleEx = 0;
		sz_e = SetCsize(sz.y, sz.x, sz.hgt, 20);
	}
	else{
		style = 0;
		styleEx = WS_EX_CLIENTEDGE;
		sz_e = SetCsize(sz.x, sz.y, sz.wdh, sz.hgt);
	}
	
	HWND hEdit = CreateWindowEx(styleEx,
				"EDIT",
				NULL,
				WS_CHILD | WS_TABSTOP | WS_VISIBLE | ES_RIGHT | style,
				sz_e.x, sz_e.y, sz_e.wdh, sz_e.hgt,
				hParent,
				(HMENU) ID_EDIT,
				GetModuleHandle(NULL),
				NULL);
	
	// tHg̐ݒ
	HGDIOBJ 	sobj = NULL;
	sobj = GetStockObject(DEFAULT_GUI_FONT);
	if(sobj == NULL)
		sobj = GetStockObject(ANSI_VAR_FONT);
	if(sobj != NULL){
		SendMessage(hEdit, WM_SETFONT, (WPARAM)sobj, MAKELPARAM(TRUE, 0));
		DeleteObject(sobj);
	}
	
	return (hEdit);
}// Set_Edit

// XC_[̍쐬
HWND Set_Slider(HWND hParent, CSIZE sz)
{
	static int k = 0;
	HWND hSlider = CreateWindowEx(0,
				TRACKBAR_CLASS,
				NULL,
				WS_CHILD | WS_TABSTOP | WS_VISIBLE | TBS_VERT | TBS_RIGHT | TBS_AUTOTICKS,
				sz.y, sz.x, sz.hgt, sz.wdh,
				hParent,
				(HMENU) 1684 + k++,
				GetModuleHandle(NULL),
				NULL);

	return (hSlider);
}// Set_Slider

// Xs̍쐬
// flag_VertFc^  1A^  0
HWND Set_Spin(HWND hParent, CSIZE sz, bool flag_Vert)
{
	UINT style;
	CSIZE sz_s;
	if(flag_Vert){
		style = UDS_HORZ;
		sz_s= SetCsize(sz.y, sz.x, sz.hgt, 20);
	}
	else{
		style = UDS_ALIGNRIGHT;
		sz_s = SetCsize(0, 0, 0, 0);
	}
	static int k = 0;
	HWND hSpin = CreateWindowEx(0,
				UPDOWN_CLASS,
				NULL,
				WS_CHILD | WS_TABSTOP | WS_VISIBLE | 
				UDS_ARROWKEYS | UDS_NOTHOUSANDS | 
				UDS_AUTOBUDDY | UDS_SETBUDDYINT | style,
				sz_s.x, sz_s.y, sz_s.wdh, sz_s.hgt,
				hParent,
				(HMENU) 1700 + k++,
				GetModuleHandle(NULL),
				NULL);

	return (hSpin);
}// Set_Spin

// Xg{bNX̍쐬
HWND Set_List(HWND hParent, CSIZE sz, UINT ID_LIST)
{
	HWND hList = CreateWindowEx(WS_EX_CLIENTEDGE,
				"LISTBOX",
				NULL,
				WS_CHILD | WS_TABSTOP | WS_VISIBLE | WS_VSCROLL | LBS_NOTIFY | LBS_NOINTEGRALHEIGHT,
				sz.x, sz.y, sz.wdh, sz.hgt,
				hParent,
				(HMENU) ID_LIST,
				GetModuleHandle(NULL),
				NULL);
	
	// tHg̐ݒ
	HGDIOBJ 	sobj = NULL;
	sobj = GetStockObject(DEFAULT_GUI_FONT);
	if(sobj == NULL)
		sobj = GetStockObject(ANSI_VAR_FONT);
	if(sobj != NULL){
		SendMessage(hList, WM_SETFONT, (WPARAM)sobj, MAKELPARAM(TRUE, 0));
		DeleteObject(sobj);
	}
	
	return (hList);
}// Set_List

// j[̃`FbNύX
bool Menu_State_Check(HMENU hMenu, UINT ID)
{
	MENUITEMINFO    mi;
	
	ZeroMemory (&mi, sizeof(mi));
	mi.cbSize = sizeof(mi);
	mi.fMask = MIIM_STATE;
	
	GetMenuItemInfo(hMenu,ID,0,&mi);
	
	if(mi.fState == MFS_UNCHECKED)
		mi.fState = MFS_CHECKED;
	else
		mi.fState = MFS_UNCHECKED;
	
	SetMenuItemInfo(hMenu,ID,0,&mi);

	if(mi.fState == MFS_UNCHECKED)
		return 0;
	return 1;
}// Menu_State_Check


CSIZE SetCsize(int x, int y, int wdh, int hgt)
{
	CSIZE sz;
	sz.x   = x;
	sz.y   = y;
	sz.wdh = wdh;
	sz.hgt = hgt;
	return sz;
}// SetCsize

SIZE Get_StrSize(HWND hWnd, HGDIOBJ sobj, char *str)
{
	HGDIOBJ sobj_pre;
	SIZE    size;
	HDC hDC = GetDC(hWnd);
	sobj_pre = SelectObject(hDC, sobj);
	GetTextExtentPoint32(hDC, str, strlen(str), &size);
	SelectObject(hDC, sobj_pre);
	DeleteObject(sobj);
	ReleaseDC(hWnd, hDC);
	return (size);
}// Get_StrSize
